//************************************************************************************
//**  
//**  File name:     F:\ATARI\TRANSKEY\FLOWCODE\TK-II\TRANSKEY-II FINAL\TK-II-OS_V1_9X.c
//**  Generated by:  Flowcode v4.5.18.74
//**  Date:          Tuesday, June 13, 2017 21:24:23
//**  Licence:       Professional
//**  Registered to: Michael St. Pierre
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P16F1847
#define MX_EE
#define MX_EE_TYPE3
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 1
#define MX_SPI_SDO 2
#define MX_SPI_SCK 4
#define MX_UART
#define MX_UART_B
#define MX_UART_TX 5
#define MX_UART_RX 2
#define MX_I2C
#define MX_I2C_B
#define MX_I2C_SDA 1
#define MX_I2C_SCL 4
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisb
#define MX_PWM_1 0
#define MX_PWM_TRIS1a trisb
#define MX_PWM_1a 3

//Functions
#define MX_CLK_SPEED 32000000
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic.h>
#endif

//Configuration data
#ifdef _BOOSTC
#pragma DATA 0x8007, 0xf9c
#endif
#ifdef HI_TECH_C
__CONFIG(0xf9c);
#endif
#ifdef _BOOSTC
#pragma DATA 0x8008, 0x1dff
#endif
#ifdef HI_TECH_C
__CONFIG(0x1dff);
#endif

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_GetKey();
void FCM_LEDupdate();
void FCM_PS2sendBit(char FCL_DATA, char FCL_CHAN);
void FCM_Symbols();
void FCM_KeySend();
void FCM_NumPad();
void FCM_InsertMode();
void FCM_KeyProc();
void FCM_ModEncode();
void FCM_StringSend(char* PFCL_TEXT);
void FCM_Ascii2Pokey();
void FCM_KeyMacros();
void FCM_ClipBoard();
void FCM_EEPROMinit();
void FCM_DoubleKey();
void FCM_CapsSync(char FCL_DELAY);
void FCM_PS2write(char FCL_DATA, char FCL_CHAN);
void FCM_PS2clkPos(char FCL_CHAN);
char FCM_ConfigRead(char FCL_INDEX, char FCL_DISPLAYEN);
void FCM_KeyDownCHK();
void FCM_CSfix();
void FCM_KeyMapDE();
void FCM_INITps2();
void FCM_WIggle(char FCL_X);
void FCM_PS2time();
void FCM_KeyMapUK();
void FCM_KeyMapA8();
void FCM_KeySend2();


//Variable declarations
char FCV_ARROWSPEED;
char FCV_LEDSAVE;
char FCV_KBINDXI;
char FCV_BAT;
char FCV_CONSOLE;
char FCV_NOATTRACT;
char FCV_PREVKEY;
char FCV_SLOW;
char FCV_CAPS;
char FCV_INSMODESAVE;
char FCV_NONKEY;
char FCV_KEYSCAN;
char FCV_KEYTIME;
char FCV_NUM;
char FCV_ADDRTEMP;
char FCV_KDATA;
char FCV_POKEEN;
char FCV_RECORD;
char FCV_BASECODE;
char FCV_TOMSSET;
char FCV_OPTIONBOOTEN;
char FCV_SIZE;
char FCV_UMENUTMP;
short FCV_TOCNT0;
char FCV_POKECODE;
char FCV_LOOP;
char FCV_TOCNT1;
char FCV_SELECTBOOTEN;
char FCV_NOSHIFT;
char FCV_CTL_KEY;
char FCV_SHF_KEY;
char FCV_BRK_KEY;
char FCV_ALT;
char FCV_IN;
char FCV_CNT;
char FCV_TEMP;
char FCV_NUMLOCK;
char FCV_KBINDXO;
char FCV_RST_KEY;
char FCV_ADDRPTR;
char FCV_POKEHOLD;
char FCV_LED;
char FCV_FLOAT;
char FCV_KR;
char FCV_SUSTAIN;
char FCV_INSMODE;
char FCV_RCTRL;
char FCV_TKCAPS;
char FCV_KBBUF[20];
char FCV_JIFFY1;
char FCV_EXT_KEY;
char FCV_ADDRBANK;
char FCV_TEMP1;
char FCV_ALPHA;
char FCV_JIFFY2;
char FCV_POKECOUNT;
char FCV_SENDCODE;
char FCV_PAUSE_KEY;
char FCV_CTRL;
char FCV_TEMP2;
char FCV_SHIFTOLD;
char FCV_TO;
char FCV_ARROWTOG;
char FCV_SHIFT;
char FCV_REL_KEY;
char FCV_OK;
char FCV_BRK_BYTES;
char FCV_POKETEMP;
char FCV_KEYMAP;
char FCV_DIAGARROWS;
char FCV_SHF_ONLY;
char FCV_KEYBD1TO;
char FCV_SCANOLD;
char FCV_SCROLL;
char FCV_CLIPBUF[32];
char FCV_CLK;
char FCV_PARITY;
char FCV_ASCII;
char FCV_LIST;
char FCV_CAPSTMP;
char FCV_POKELAST;
char FCV_RESYNC;
char FCV_KEYBD2TO;
char FCV_SCANCODE;
char FCV_UMENU;
char FCV_ALTGR;
char FCV_MENUB;
char FCV_HOLD;

char FCLV_LOOP1;
char FCLV_LOOP2;
char FCLV_LOOP3;
char FCLV_LOOP4;



//EEPROM(0): //Defines:

/**** Macro Substitutions ****
******************************/




//EEPROM(0): //Macro function declarations

char FCD_EEPROM0_EEPROMRead(short addr);
void FCD_EEPROM0_WriteEEPROM(short addr, char data);

//Supplementary defines
rom char* ascii_tbl1 =
	{
	0x00,0x17,0x00,0x13,0x11,0x0F,0x10,0x1A,
	0x00,0x18,0x16,0x14,0x12,0x09,0x60,0x00,
	0x00,0x00,0x00,0x00,0x00,0x71,0x31,0x00,
	0x00,0x00,0x7A,0x73,0x61,0x77,0x32,0x0A,
	0x00,0x63,0x78,0x64,0x65,0x34,0x33,0x0B,
	0x00,0x20,0x76,0x66,0x74,0x72,0x35,0x0C,
	0x00,0x6E,0x62,0x68,0x67,0x79,0x36,0x00,
	0x00,0x00,0x6D,0x6A,0x75,0x37,0x38,0x00,
	0x00,0x2C,0x6B,0x69,0x6F,0x30,0x39,0x00,
	0x00,0x2E,0x2F,0x6C,0x3B,0x70,0x2D,0x00,
	0x00,0x00,0x27,0x00,0x5B,0x3D,0x00,0x00,
	0x00,0x00,0x0D,0x5D,0x00,0x5C,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,
	0x00,0xB1,0x00,0xB4,0xB7,0x00,0x00,0x00,
	0xB0,0xAE,0xB2,0xB5,0xB6,0xB8,0x1B,0x00,
	0x19,0xAB,0xB3,0xAD,0xAA,0xB9,0x07,0x00,
	0x00,0x00,0x00,0x15
    };
rom char* ascii_tbl2 =
	{
	0x29,0x21,0x40,0x23,0x24,0x25,0x5E,0x26,
	0x2A,0x28
    };
rom char* nav_tbl =
	{
	0x01,0x04,0x1F,0x06,0x1C,0x00,0x1D,0x03,
	0x1E,0x05,0x2A,0x2B,0x00,0x2D,0x02
    };



//EEPROM(0): //Macro implementations


char FCD_EEPROM0_EEPROMRead(short addr)
{
		char data = 0;

		#ifdef MX_EE
			#ifdef _BOOSTC

				#ifndef MX_EEADR
					#ifdef EEADR
						#define MX_EEADR eeadr
					#endif
					#ifdef EEADRL
						//#define MX_EEADR eeadrl
					#endif
				#endif
				#ifndef MX_EEDATA
					#ifdef EEDATA
						#define MX_EEDATA eedata
					#endif
					#ifdef EEDATAL
						#define MX_EEDATA eedatal
					#endif
					#ifdef EEDATL
						//#define MX_EEDATA eedatl
					#endif
				#endif

				#ifndef MX_EEADR	//Catch Error
					#error "EEPROM error - MX_EEADR not set"
				#endif

				#ifndef MX_EEDATA
					#error "EEPROM error - MX_EEDATA not set"
				#endif

				MX_EEADR = addr & 0xff;
				#if (MX_EE_SIZE > 256)
					eeadrh = (addr & 0xff00) >> 8;
				#endif
				#ifdef MX_EE_TYPE2
					clear_bit(eecon1, EEPGD);
				#endif
				#ifdef MX_EE_TYPE3
					clear_bit(eecon1, EEPGD);
					clear_bit(eecon1, CFGS);
				#endif
				set_bit(eecon1, RD);
				data = MX_EEDATA;

			#endif

			#ifdef HI_TECH_C

				data = eeprom_read(addr);

			#endif
		#else
			#ifdef MX_EE_TYPE67X
				#error "FlowCode does not support EEPROM for this device"
			#else
				#ifdef MX_EE_TYPE62X
					#error "FlowCode does not support EEPROM for this device"
				#else
					#error "Chip does not have EEPROM memory"
				#endif
			#endif
		#endif
		return (data);

}

void FCD_EEPROM0_WriteEEPROM(short addr, char data)
{
	
		#ifdef MX_EE
			#ifdef _BOOSTC

				#ifndef MX_EEADR
					#ifdef EEADR
						#define MX_EEADR eeadr
					#endif
					#ifdef EEADRL
						#define MX_EEADR eeadrl
					#endif
				#endif
				#ifndef MX_EEDATA
					#ifdef EEDATA
						#define MX_EEDATA eedata
					#endif
					#ifdef EEDATAL
						#define MX_EEDATA eedatal
					#endif
				#endif

				#ifndef MX_EEADR	//Catch Error
					#error "EEPROM error - MX_EEADR not set"
				#endif

				#ifndef MX_EEDATA
					#error "EEPROM error - MX_EEDATA not set"
				#endif

				char bInterruptsEnabled;

				//wait for previous EE writes to complete...
				while (test_bit(eecon1, WR));

				MX_EEADR = addr & 0xff;
				#if (MX_EE_SIZE > 256)
					eeadrh = (addr & 0xff00) >> 8;
				#endif
				MX_EEDATA = data;
				#ifdef MX_EE_TYPE2
					clear_bit(eecon1, EEPGD);
				#endif
				#ifdef MX_EE_TYPE3
					clear_bit(eecon1, EEPGD);
					clear_bit(eecon1, CFGS);
				#endif
				set_bit(eecon1, WREN);
				bInterruptsEnabled = test_bit(intcon, GIE);
				clear_bit(intcon, GIE);			//Disable Interrupts

				eecon2 = 0x55;
				eecon2 = 0xAA;
				set_bit(eecon1, WR);
				while (test_bit(eecon1, WR));	//wait for EE write to complete...

				if (bInterruptsEnabled)
					set_bit(intcon, GIE);		//Re-enable Interrupts
				clear_bit(eecon1, WREN);

			#endif
			#ifdef HI_TECH_C

				eeprom_write(addr, data);

			#endif
		#else
			#ifdef MX_EE_TYPE67X
				#error "FlowCode does not support EEPROM for this device"
			#else
				#ifdef MX_EE_TYPE62X
					#error "FlowCode does not support EEPROM for this device"
				#else
					#error "Chip does not have EEPROM memory"
				#endif
			#endif
		#endif
}

//Macro implementations

void FCM_GetKey()
{
	//GetKey -- This interrupt macro services key presses, and retrieves the scancodes that represent each key.
	//A call is automatically made to this routine when the keyboard clock line goes low.
	//This routine is bypassed during PS/2 Host-To-Device Com.
	
	//inc. counter
	//Calculation:
	//  cnt = cnt+1
	FCV_CNT = FCV_CNT+1;
	

	//Get CLKs
	//Input: PORTB -> clk
	trisb = trisb | 0x05;
	FCV_CLK = portb & 0x05;


	//Port 2 activity ?
	//Decision: clk=0?
	if (FCV_CLK==0)
	{
		//Comment:
		//PS/2 Port #2 connections:
		//clock--> RB2
		//data --> RB3


		//Read CLK Port 2
		//Input: B2 -> clk
		trisb = trisb | 0x04;
		FCV_CLK = ((portb & 0x04) == 0x04);


		//Read Data Port 2
		//Input: B3 -> in
		trisb = trisb | 0x08;
		FCV_IN = ((portb & 0x08) == 0x08);


		//Verify Activity
		//Decision: clk=0?
		if (FCV_CLK==0)
		{
			//Reset Time-Out
			//Calculation:
			//  KeyBd2TO = 0
			FCV_KEYBD2TO = 0;
			

		}


	} else {
		//Comment:
		//PS/2 Port #1 connections:
		//clock--> RB0
		//data --> RB1


		//Read CLK Port 1
		//Input: B0 -> clk
		trisb = trisb | 0x01;
		FCV_CLK = ((portb & 0x01) == 0x01);


		//Read Data Port 1
		//Input: B1 -> in
		trisb = trisb | 0x02;
		FCV_IN = ((portb & 0x02) == 0x02);


		//Verify Activity
		//Decision: clk=0?
		if (FCV_CLK==0)
		{
			//Reset Time-Out
			//Calculation:
			//  KeyBd1TO = 0
			FCV_KEYBD1TO = 0;
			

		}


	}


	//START bit ? (ignore)
	//Decision: ( cnt = 1 ) AND ( in = 0 ) AND (clk=0)?
	if (( FCV_CNT == 1 ) & ( FCV_IN == 0 ) & (FCV_CLK==0))
	{
	} else {
		//PARITY ? (Ignore)
		//Decision: (cnt = 10) AND (clk=0)?
		if ((FCV_CNT == 10) & (FCV_CLK==0))
		{
		} else {
			//STOP bit ?
			//Decision: ( cnt = 11 ) AND ( in = 1 ) AND (clk=0)?
			if (( FCV_CNT == 11 ) & ( FCV_IN == 1 ) & (FCV_CLK==0))
			{
				//Comment:
				//Done collecting data bits,
				//time to process it
				//(kdata holds scancode).


				//Request to resend data ?
				//Decision: kdata=0xFE?
				if (FCV_KDATA==0xFE)
				{
				} else {
					//Error ?
					//Decision: kdata=0xFF?
					if (FCV_KDATA==0xFF)
					{
					} else {
						//ACK or BAT ? (Ignore)
						//Decision: kdata =0xFA OR kdata =0xAA?
						if (FCV_KDATA ==0xFA | FCV_KDATA ==0xAA)
						{
							//New keyboard online ?
							//Decision: kdata=0xAA?
							if (FCV_KDATA==0xAA)
							{
								//Flag it
								//Calculation:
								//  BAT = 1
								FCV_BAT = 1;
								

							}


						} else {
							//Key Up ?
							//Decision: kdata=0xF0?
							if (FCV_KDATA==0xF0)
							{
								//
								//Calculation:
								//  KEYscan = 0
								//  Sustain = 0
								FCV_KEYSCAN = 0;
								FCV_SUSTAIN = 0;
								

							} else {
								//
								//Calculation:
								//  KEYscan = 1
								FCV_KEYSCAN = 1;
								

							}


							//Top of Buffer ?
							//Decision: KBindxI = 20?
							if (FCV_KBINDXI == 20)
							{
								//Reset to beginning
								//Calculation:
								//  KBindxI = 0
								FCV_KBINDXI = 0;
								

							}


							//Store key in Buffer
							//Calculation:
							//  KBbuf[KBindxI] = kdata
							//  KBindxI = KBindxI+1
							//  kdata = 0
							FCV_KBBUF[FCV_KBINDXI] = FCV_KDATA;
							FCV_KBINDXI = FCV_KBINDXI+1;
							FCV_KDATA = 0;
							

						}


					}


				}


				//Done! Reset Registers
				//Calculation:
				//  kdata = 0
				//  cnt = 0
				FCV_KDATA = 0;
				FCV_CNT = 0;
				

			} else {
				//Clock is low ?
				//Decision: clk=0?
				if (FCV_CLK==0)
				{
					//Comment:
					//Shift individual bits
					//into data byte.


					//data right shift
					//Calculation:
					//  kdata = kdata >> 1
					FCV_KDATA = FCV_KDATA >> 1;
					

					//bit is 1?
					//Decision: in?
					if (FCV_IN)
					{
						//place 1 bit msb
						//Calculation:
						//  kdata = kdata | 0x80
						FCV_KDATA = FCV_KDATA | 0x80;
						

					}


				} else {
					//Done! Reset Registers
					//Calculation:
					//  kdata = 0
					//  cnt = 0
					FCV_KDATA = 0;
					FCV_CNT = 0;
					

				}


			}


		}


	}


}

void FCM_LEDupdate()
{
	//LEDupdate -- Entry point to change the state of the keyboard LEDs.
	//Requires that the 'LED' variable be set prior to calling this routine.
	//(Bit0 = Scroll Lock, Bit1=Num Lock, Bit2=Caps Lock)
	
	//Disable GetKey Interrupt
	//Interrupt: Disable RB0INT
	cr_bit(intcon, INTE);


	//Keyboard Time-Out ?
	//Decision: KeyBd1TO?
	if (FCV_KEYBD1TO)
	{
	} else {
		//Send LED Command
		//Call Macro: PS2write(0xED, 0)
		FCM_PS2write(0xED, 0);


		//Comment:
		//Before sending the 2nd byte,
		//we need to allow the keyboard
		//to send it's acknowledgement.


		//Delay
		//Delay: 3 ms
		delay_ms(3);


		//Comment:
		//===============
		//Update Keyboard
		//Port 1 LEDs
		//===============


		//Update keyboard LEDs
		//Call Macro: PS2write(LED, 0)
		FCM_PS2write(FCV_LED, 0);


		//Delay
		//Delay: 5 ms
		delay_ms(5);


	}


	//Keyboard Time-Out ?
	//Decision: KeyBd2TO?
	if (FCV_KEYBD2TO)
	{
	} else {
		//Send LED Command
		//Call Macro: PS2write(0xED, 1)
		FCM_PS2write(0xED, 1);


		//Comment:
		//Before sending the 2nd byte,
		//we need to allow the keyboard
		//to send it's acknowledgement.


		//Delay
		//Delay: 3 ms
		delay_ms(3);


		//Comment:
		//===============
		//Update Keyboard
		//Port 2 LEDs
		//===============


		//Update keyboard LEDs
		//Call Macro: PS2write(LED, 1)
		FCM_PS2write(FCV_LED, 1);


		//Delay
		//Delay: 5 ms
		delay_ms(5);


	}


	//Comment:
	//Since GetKey was shut
	//down, we might have
	//dropped some key data,
	//so best to clear it.


	//Reset Key Buffer
	//Calculation:
	//  KBindxI = KBindxO
	//  SCANold = 0
	//  ok = 0
	//  cnt = 0
	//  kdata = 0
	//  KEYscan = 0
	FCV_KBINDXI = FCV_KBINDXO;
	FCV_SCANOLD = 0;
	FCV_OK = 0;
	FCV_CNT = 0;
	FCV_KDATA = 0;
	FCV_KEYSCAN = 0;
	

	//Enable GetKey IRQ
	//Interrupt: Enable RB0INT
	cr_bit(option_reg,INTEDG);
	st_bit(intcon,GIE);
	st_bit(intcon, INTE);


}

void FCM_PS2sendBit(char FCL_DATA, char FCL_CHAN)
{
	//SendBit -- Does the actual sending of each bit for PS/2 Host-to-Device Com.
	
	//Local variable definitions
	char FCL_CLK;

	//Reset TimeOut Counter
	//Calculation:
	//  TOcnt1 = 0
	FCV_TOCNT1 = 0;
	

	//Wait for clock line to go low
	//Loop: While PS2sendBit.CLK
	while (1)
	{
		//Check Elasped Time
		//Call Macro: PS2time
		FCM_PS2time();


		//Time Out ?
		//Decision: TOcnt1>TOmsSet?
		if (FCV_TOCNT1>FCV_TOMSSET)
		{
			//Goto Connection Point
			//Goto Connection Point: [A]: A
			goto FCC_PS2sendBit_A;


		}


		//2nd Keyboard ?
		//Decision: PS2sendBit.chan?
		if (FCL_CHAN)
		{
			//Grab clock line state
			//Input: B2 -> PS2sendBit.CLK
			trisb = trisb | 0x04;
			FCL_CLK = ((portb & 0x04) == 0x04);


		} else {
			//Grab clock line state
			//Input: B0 -> PS2sendBit.CLK
			trisb = trisb | 0x01;
			FCL_CLK = ((portb & 0x01) == 0x01);


		}


		if ((FCL_CLK) == 0) break;
	}


	//Comment:
	//Send data bit to keyboard


	//Bit = 1?
	//Decision: PS2sendBit.data AND 0x01?
	if (FCL_DATA & 0x01)
	{
		//Comment:
		//Releasing the data line
		//is the same as a logic '1'
		//due to the keyboard's open
		//collector pull-up resistor


		//2nd Keyboard ?
		//Decision: PS2sendBit.chan?
		if (FCL_CHAN)
		{
			//Release data line
			//Input: B3 -> PS2sendBit.CLK
			trisb = trisb | 0x08;
			FCL_CLK = ((portb & 0x08) == 0x08);


		} else {
			//Release data line
			//Input: B1 -> PS2sendBit.CLK
			trisb = trisb | 0x02;
			FCL_CLK = ((portb & 0x02) == 0x02);


		}


	} else {
		//2nd Keyboard ?
		//Decision: PS2sendBit.chan?
		if (FCL_CHAN)
		{
			//Send '0' bit
			//Output: 0 -> B3
			trisb = trisb & 0xf7;
			if (0)
				portb = (portb & 0xf7) | 0x08;
			else
				portb = portb & 0xf7;


		} else {
			//Send '0' bit
			//Output: 0 -> B1
			trisb = trisb & 0xfd;
			if (0)
				portb = (portb & 0xfd) | 0x02;
			else
				portb = portb & 0xfd;


		}


	}


	//Wait for clock line to go high
	//Loop: While PS2sendBit.CLK=0
	while (1)
	{
		//Check Elasped Time
		//Call Macro: PS2time
		FCM_PS2time();


		//Time Out ?
		//Decision: TOcnt1>TOmsSet?
		if (FCV_TOCNT1>FCV_TOMSSET)
		{
			//Goto Connection Point
			//Goto Connection Point: [A]: A
			goto FCC_PS2sendBit_A;


		}


		//2nd Keyboard ?
		//Decision: PS2sendBit.chan?
		if (FCL_CHAN)
		{
			//Grab clock line state
			//Input: B2 -> PS2sendBit.CLK
			trisb = trisb | 0x04;
			FCL_CLK = ((portb & 0x04) == 0x04);


		} else {
			//Grab clock line state
			//Input: B0 -> PS2sendBit.CLK
			trisb = trisb | 0x01;
			FCL_CLK = ((portb & 0x01) == 0x01);


		}


		if ((FCL_CLK==0) == 0) break;
	}


	//Connection Point
	//Connection Point: [A]: A
FCC_PS2sendBit_A:
;


	//Device Time Out ?
	//Decision: TOcnt1>TOmsSet?
	if (FCV_TOCNT1>FCV_TOMSSET)
	{
		//2nd Keyboard ?
		//Decision: PS2sendBit.chan?
		if (FCL_CHAN)
		{
			//Disable Keyboard 2 Calls
			//Calculation:
			//  KeyBd2TO = 1
			FCV_KEYBD2TO = 1;
			

		} else {
			//Disable Keyboard 1 Calls
			//Calculation:
			//  KeyBd1TO = 1
			FCV_KEYBD1TO = 1;
			

		}


	}


}

void FCM_Symbols()
{
	//In response to a SHIFT key being down, this routine replaces the associated upper character on the alphanumeric keys with the correct ASCII code for that symbol.
	
	//Numbers ?
	//Decision: ASCII>0x2F AND ASCII<0x3A?
	if (FCV_ASCII>0x2F & FCV_ASCII<0x3A)
	{
		//Comment:
		//If this is a number key on
		//the main keyboard, then
		//translate to upper symbol
		//using table (ascii_tbl2).


		//Create table index
		//Calculation:
		//  temp = ASCII-0x30
		FCV_TEMP = FCV_ASCII-0x30;
		

		//Comment:
		//SYMBOL-TO-ASCII LUT
		//Translate number keys into
		//upper character symbols.


		//C Code
		//C Code:
		/*  Get upper ASCII characters
			using look-up table stored in...
			View-Project Options-supplementary code
		*/

		FCV_ASCII=ascii_tbl2[FCV_TEMP];


	}


	//Comment:
	//Translate other upper key
	//symbols as needed.


	//Tilde Key
	//Decision: SCANcode=0x0E?
	if (FCV_SCANCODE==0x0E)
	{
		//
		//Calculation:
		//  ASCII = 0x7E
		FCV_ASCII = 0x7E;
		

	}


	//Asterist *
	//Decision: SCANcode=0x3E?
	if (FCV_SCANCODE==0x3E)
	{
		//
		//Calculation:
		//  ASCII = 0x2A
		//  NOshift = 1
		FCV_ASCII = 0x2A;
		FCV_NOSHIFT = 1;
		

	}


	//Less Than <
	//Decision: SCANcode=0x41?
	if (FCV_SCANCODE==0x41)
	{
		//
		//Calculation:
		//  ASCII = 0x3C
		//  NOshift = 1
		FCV_ASCII = 0x3C;
		FCV_NOSHIFT = 1;
		

	}


	//Greater Than >
	//Decision: SCANcode=0x49?
	if (FCV_SCANCODE==0x49)
	{
		//
		//Calculation:
		//  ASCII = 0x3E
		//  NOshift = 1
		FCV_ASCII = 0x3E;
		FCV_NOSHIFT = 1;
		

	}


	//Question Mark ?
	//Decision: SCANcode=0x4A?
	if (FCV_SCANCODE==0x4A)
	{
		//
		//Calculation:
		//  ASCII = 0x3F
		FCV_ASCII = 0x3F;
		

	}


	//Colon :
	//Decision: SCANcode=0x4C?
	if (FCV_SCANCODE==0x4C)
	{
		//
		//Calculation:
		//  ASCII = 0x3A
		FCV_ASCII = 0x3A;
		

	}


	//Under Line _
	//Decision: SCANcode=0x4E?
	if (FCV_SCANCODE==0x4E)
	{
		//
		//Calculation:
		//  ASCII = 0x5F
		FCV_ASCII = 0x5F;
		

	}


	//Quotes "
	//Decision: SCANcode=0x52?
	if (FCV_SCANCODE==0x52)
	{
		//
		//Calculation:
		//  ASCII = 0x22
		FCV_ASCII = 0x22;
		

	}


	//Left Brace {
	//Decision: SCANcode=0x54?
	if (FCV_SCANCODE==0x54)
	{
		//
		//Calculation:
		//  ASCII = 0x7B
		//  NOshift = 1
		FCV_ASCII = 0x7B;
		FCV_NOSHIFT = 1;
		

	}


	//Plus +
	//Decision: SCANcode=0x55?
	if (FCV_SCANCODE==0x55)
	{
		//
		//Calculation:
		//  ASCII = 0x2B
		//  NOshift = 1
		FCV_ASCII = 0x2B;
		FCV_NOSHIFT = 1;
		

	}


	//Right Brace }
	//Decision: SCANcode=0x5B?
	if (FCV_SCANCODE==0x5B)
	{
		//
		//Calculation:
		//  ASCII = 0x7D
		//  NOshift = 1
		FCV_ASCII = 0x7D;
		FCV_NOSHIFT = 1;
		

	}


	//Vertical Line |
	//Decision: SCANcode=0x5D?
	if (FCV_SCANCODE==0x5D)
	{
		//
		//Calculation:
		//  ASCII = 0x7C
		FCV_ASCII = 0x7C;
		

	}


}

void FCM_KeySend()
{
	//This routine sends a key to POKEY and loops until the key has passed.
	//It has no local variables, and requires that POKEcode hold the key to be sent with POKEen set to 1 prior to entry. Used by ClipBoard and StringSend routines.
	
	//
	//Calculation:
	//  SCANold = SCANcode
	FCV_SCANOLD = FCV_SCANCODE;
	

	//Send Loop
	//Loop: While POKEen=0
	while (1)
	{
		//Get POKEY Count Value
		//Input: PORTA -> POKEcount
		trisa = trisa | 0x3f;
		FCV_POKECOUNT = porta & 0x3f;


		//Send Keys ?
		//Decision: POKEen?
		if (FCV_POKEEN)
		{
			//Is this a MOD key code?
			//Decision: POKEcode=0x36?
			if (FCV_POKECODE==0x36)
			{
				//Comment:
				//POKEcode 0x36 is a Dummy
				//Code that flags a No Send
				//Key condition.
				//(ie;SHIFT, CTRL, ALT, BRK)


			} else {
				//Match Standard Key ?
				//Decision: (POKEcode & 0x3F) = POKEcount?
				if ((FCV_POKECODE & 0x3F) == FCV_POKECOUNT)
				{
					//Bring KR1 (bit-6) Low
					//Output: 0 -> A6
					trisa = trisa & 0xbf;
					if (0)
						porta = (porta & 0xbf) | 0x40;
					else
						porta = porta & 0xbf;


					//U-1meg Menu ?
					//Decision: Umenu>0 AND Umenu<11  AND POKEhold=11?
					if (FCV_UMENU>0 & FCV_UMENU<11  & FCV_POKEHOLD==11)
					{
						//Comment:
						//== U-1meg Menu Routine ==
						//  F12 sends HELP+RESET
						// which launches U-1meg
						//      Set-Up Menu


						//Decision
						//Decision: Umenu=1?
						if (FCV_UMENU==1)
						{
							//Output (RESET)
							//Output: 0 -> B7
							trisb = trisb & 0x7f;
							if (0)
								portb = (portb & 0x7f) | 0x80;
							else
								portb = portb & 0x7f;


						} else {
							//Decision
							//Decision: Umenu=2?
							if (FCV_UMENU==2)
							{
								//Float Reset Line
								//Input: B7 -> temp
								trisb = trisb | 0x80;
								FCV_TEMP = ((portb & 0x80) == 0x80);


							}


						}


						//Decision
						//Decision: Umenu=10?
						if (FCV_UMENU==10)
						{
							//Comment:
							//--- Last Pass ---
							//Time to terminate
							//HELP key send.


							//Reset Count
							//Calculation:
							//  Umenu = 0
							//  SCANold = 0
							//  Nonkey = 1
							FCV_UMENU = 0;
							FCV_SCANOLD = 0;
							FCV_NONKEY = 1;
							

						} else {
							//Increment Count
							//Calculation:
							//  Umenu = Umenu+1
							FCV_UMENU = FCV_UMENU+1;
							

						}


					}


				} else {
					//Make KR1 (bit-6) High
					//Output: 1 -> A6
					trisa = trisa & 0xbf;
					if (1)
						porta = (porta & 0xbf) | 0x40;
					else
						porta = porta & 0xbf;


				}


			}


			//Comment:
			//Extract just the MOD bits
			//from POKEcode.
			//Bit6=CTRL, Bit7=SHIFT.


			//Shift ?
			//Decision: POKEcode & 0x80?
			if (FCV_POKECODE & 0x80)
			{
				//Set Shift Key Down
				//Calculation:
				//  shf_key = 0x2F
				FCV_SHF_KEY = 0x2F;
				

			}


			//Control ?
			//Decision: POKEcode & 0x40?
			if (FCV_POKECODE & 0x40)
			{
				//Set Control Key Down
				//Calculation:
				//  ctl_key = 0x3F
				FCV_CTL_KEY = 0x3F;
				

			}


			//Comment:
			//SHIFT and CTRL keys
			//are set and ready to be
			//compared to POKEY's
			//Scan Counter.


			//Comment:
			//If POKEY's scan count
			//matches Break, Control,
			//or Shift key then do it.


			//Match ?
			//Decision: (brk_key = POKEcount OR (POKEcount > shf_key-10 AND POKEcount < shf_key+10) OR (POKEcount > ctl_key-10 AND POKEcount < ctl_key+10)) AND POKEcount>0?
			if ((FCV_BRK_KEY == FCV_POKECOUNT | (FCV_POKECOUNT > FCV_SHF_KEY-10 & FCV_POKECOUNT < FCV_SHF_KEY+10) | (FCV_POKECOUNT > FCV_CTL_KEY-10 & FCV_POKECOUNT < FCV_CTL_KEY+10)) & FCV_POKECOUNT>0)
			{
				//Bring KR2 (bit-7) Low
				//Output: 0 -> A7
				trisa = trisa & 0x7f;
				if (0)
					porta = (porta & 0x7f) | 0x80;
				else
					porta = porta & 0x7f;


			} else {
				//Make KR2 (bit-7) High
				//Output: 1 -> A7
				trisa = trisa & 0x7f;
				if (1)
					porta = (porta & 0x7f) | 0x80;
				else
					porta = porta & 0x7f;


			}


		} else {
			//Comment:
			//No valid key data
			//for POKEY yet


		}


		//Comment:
		//For every time the POKEY
		//counter hits the top
		//increment the key hold
		//time counter


		//Counter Overflow?
		//Decision: POKEcount =0x3F?
		if (FCV_POKECOUNT ==0x3F)
		{
			//Increment Hold Count
			//Calculation:
			//  POKEhold = POKEhold+1
			//  JIFFY1 = JIFFY1+1
			FCV_POKEHOLD = FCV_POKEHOLD+1;
			FCV_JIFFY1 = FCV_JIFFY1+1;
			

			//Counter Overflow ?
			//Decision: JIFFY1=0?
			if (FCV_JIFFY1==0)
			{
				//Increment 2nd  Counter
				//Calculation:
				//  JIFFY2 = JIFFY2+1
				FCV_JIFFY2 = FCV_JIFFY2+1;
				

			}


		}


		//Comment:
		//When the key has been held
		//for the time dictated by the
		//count, reset counter and
		//disable key send


		//Hold time over ?
		//Decision: (POKEhold=KeyTime) OR (POKEen=0)?
		if ((FCV_POKEHOLD==FCV_KEYTIME) | (FCV_POKEEN==0))
		{
			//Comment:
			//Terminate KR2 Send


			//Make KR2 (bit-7) High
			//Output: 1 -> A7
			trisa = trisa & 0x7f;
			if (1)
				porta = (porta & 0x7f) | 0x80;
			else
				porta = porta & 0x7f;


			//Reset Key Hold Counter
			//Calculation:
			//  POKEhold = 0
			FCV_POKEHOLD = 0;
			

			//Still doing HELP+RESET ?
			//Decision: Umenu>0?
			if (FCV_UMENU>0)
			{
				//Keep Sending !
				//Goto Connection Point: [A]: A
				goto FCC_KeySend_A;


			}


			//Manual Caps Re-Sync ?
			//Decision: resync?
			if (FCV_RESYNC)
			{
				//Clear Caps Send
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//Retrieve next key
			//Call Macro: KeyProc
			FCM_KeyProc();


			//Key Send ?
			//Decision: POKEen=1?
			if (FCV_POKEEN==1)
			{
				//Comment:
				//====== BEGIN ======
				//Sustained Key Routine
				//==================


				//Release While Sustained ?
				//Decision: SCANcode=0xF0?
				if (FCV_SCANCODE==0xF0)
				{
					//Loop Until Release Passes
					//Loop: While SCANcode=0xF0
					while (1)
					{
						//Get Key for Compare
						//Call Macro: KeyProc
						FCM_KeyProc();


						if ((FCV_SCANCODE==0xF0) == 0) break;
					}


					//Present Key Released ?
					//Decision: SCANold=SCANcode?
					if (FCV_SCANOLD==FCV_SCANCODE)
					{
						//
						//Calculation:
						//  resync = 0
						FCV_RESYNC = 0;
						

					} else {
						//Restore Sustained Key
						//Calculation:
						//  SCANcode = SCANold
						FCV_SCANCODE = FCV_SCANOLD;
						

						//Keep Sending !
						//Goto Connection Point: [A]: A
						goto FCC_KeySend_A;


					}


				} else {
					//Extended Key ?
					//Decision: SCANcode=0xE0?
					if (FCV_SCANCODE==0xE0)
					{
						//Loop Until E0 Code Passes
						//Loop: While SCANcode=0xE0
						while (1)
						{
							//Retrieve next key
							//Call Macro: KeyProc
							FCM_KeyProc();


							if ((FCV_SCANCODE==0xE0) == 0) break;
						}


					}


					//Same Key ?
					//Decision: SCANold=SCANcode?
					if (FCV_SCANOLD==FCV_SCANCODE)
					{
						//Non Keyboard Call ?
						//Decision: Nonkey?
						if (FCV_NONKEY)
						{
						} else {
							//
							//Calculation:
							//  ok = 0
							FCV_OK = 0;
							

							//Keep Sending !
							//Goto Connection Point: [A]: A
							goto FCC_KeySend_A;


						}


					}


				}


				//Comment:
				//====== END ======
				//Sustained Key Routine
				//==================


			}


			//Comment:
			//Bypass this termination
			//code if same key is being
			//held down (sustained).


			//
			//Calculation:
			//  POKEen = 0
			//  NOshift = 0
			//  shf_key = 0
			//  ctl_key = 0
			//  brk_key = 0
			//  Nonkey = 0
			FCV_POKEEN = 0;
			FCV_NOSHIFT = 0;
			FCV_SHF_KEY = 0;
			FCV_CTL_KEY = 0;
			FCV_BRK_KEY = 0;
			FCV_NONKEY = 0;
			

			//Float KR1 and KR2 ?
			//Decision: float?
			if (FCV_FLOAT)
			{
				//Comment:
				//Set KR1 and KR2 as
				//inputs and allow
				//pull-up resistors
				//to bring them High.


				//KR1 and KR2 Float HI
				//Input: PORTA -> KR
				trisa = trisa | 0xc0;
				FCV_KR = porta & 0xc0;


			} else {
				//Comment:
				//Set KR1 and KR2 as
				//ACTIVE High outputs,
				//where no pull-up
				//resistors exist.


				//KR1 and KR2 Output HI
				//Output: 0xC0 -> PORTA
				trisa = trisa & 0x3f;
				porta = (porta & 0x3f) | (0xC0 & 0xc0);


			}


		}


		//Connection Point
		//Connection Point: [A]: A
FCC_KeySend_A:
;


		if ((FCV_POKEEN==0) != 0) break;
	}


}

void FCM_NumPad()
{
	//This routine handles the NumPad and navigation keys.
	
	//EITHER Num Lock or Shift ?
	//Decision: (SHIFT XOR NUMlock)  AND NOT ext_key?
	if ((FCV_SHIFT ^ FCV_NUMLOCK)  & ~ FCV_EXT_KEY)
	{
		//Comment:
		//Non-Extended keys
		//processed here.
		//(NumPad ONLY)


		//Comment:
		//ONLY singular Num Lock,
		//or SHIFT, not both.


		//Convert to ASCII numeric
		//Calculation:
		//  ASCII = ASCII-0x80
		//  NOshift = 1
		FCV_ASCII = FCV_ASCII-0x80;
		FCV_NOSHIFT = 1;
		

	} else {
		//Comment:
		//Start Processing
		//Navigation keys.


		//Symbols ?
		//Decision: ASCII<0xAF?
		if (FCV_ASCII<0xAF)
		{
			//Symbol index
			//Calculation:
			//  temp = ASCII-0xA0
			FCV_TEMP = FCV_ASCII-0xA0;
			

		} else {
			//Nav index
			//Calculation:
			//  temp = ASCII-0xB0
			FCV_TEMP = FCV_ASCII-0xB0;
			

		}


		//Comment:
		//NAV-TO-ASCII LUT
		//Translate into alternative
		//index for POKEY Table
		//look-up.


		//C Code
		//C Code:
		/*  Translate ASCIIE to NAV keycode
			using look-up table stored in...
			View-Project Options-supplementary code
		*/

		FCV_ASCII=nav_tbl[FCV_TEMP];


		//SHIFT Insert, Delete, Home ?
		//Decision: SHIFT AND  ((ASCII>0 AND ASCII<4) AND NOT CTRL)?
		if (FCV_SHIFT &  ((FCV_ASCII>0 & FCV_ASCII<4) & ~ FCV_CTRL))
		{
			//HOME on Numpad ?
			//Decision: SCANcode=0x6C AND NOT ext_key?
			if (FCV_SCANCODE==0x6C & ~ FCV_EXT_KEY)
			{
			} else {
				//Comment:
				//Modify index pointer to
				//reach into upper area
				//(0x14-0x16) and get
				//shifted POKEcode variant.


				//Comment:
				//Ext-Home will be changed
				//to SHIFTED Clear.


				//
				//Calculation:
				//  ASCII = ASCII+0x13
				FCV_ASCII = FCV_ASCII+0x13;
				

			}


		}


		//Arrows or Symbols ?
		//Decision: ((ASCII>0x1B AND ASCII<0x2F) OR ASCII=0x35) AND NOT ext_key?
		if (((FCV_ASCII>0x1B & FCV_ASCII<0x2F) | FCV_ASCII==0x35) & ~ FCV_EXT_KEY)
		{
			//Comment:
			//Disable SHIFT with
			//Arrow keys or symbols
			//when not an extended key.


			//
			//Calculation:
			//  NOshift = 1
			FCV_NOSHIFT = 1;
			

		}


	}


}

void FCM_InsertMode()
{
	//Insert Mode is toggled by pressing the ALT-I key, and uses the Scroll lock LED as the Insert Mode ON indicator. This mode will push characters right when typing, and erase the spaces when backspacing, just like a PC.
	
	//Local variable definitions
	char FCL_TEMP;

	//Comment:
	//Evaluate what keys
	//should be ignored
	//by Insert Mode
	//(bypass if true).


	//Modifier key ?
	//Decision: SCANcode=0?
	if (FCV_SCANCODE==0)
	{
	} else {
		//Nav/Numpad key ?
		//Decision: ((SCANcode>0x68 AND SCANcode<0x79) OR SCANcode=0x7A OR SCANcode=0x7D) AND SCANcode<>0x76?
		if (((FCV_SCANCODE>0x68 & FCV_SCANCODE<0x79) | FCV_SCANCODE==0x7A | FCV_SCANCODE==0x7D) & FCV_SCANCODE!=0x76)
		{
			//Extended key ?
			//Decision: ext_key?
			if (FCV_EXT_KEY)
			{
				//Exceptions ?
				//Decision: SCANcode=0x4A OR (ArrowTog AND (SCANcode=0x6B OR SCANcode=0x72 OR SCANcode=0x74 OR SCANcode=0x75) AND (CTRL<>1))?
				if (FCV_SCANCODE==0x4A | (FCV_ARROWTOG & (FCV_SCANCODE==0x6B | FCV_SCANCODE==0x72 | FCV_SCANCODE==0x74 | FCV_SCANCODE==0x75) & (FCV_CTRL!=1)))
				{
					//Goto Connection Point
					//Goto Connection Point: [A]: A
					goto FCC_InsertMode_A;


				}


			} else {
				//Num Lock ON ?
				//Decision: NUMlock?
				if (FCV_NUMLOCK)
				{
					//Num Lock and Shift ?
					//Decision: SHIFT?
					if (FCV_SHIFT)
					{
					} else {
						//Comment:
						//Comment


						//Goto Connection Point
						//Goto Connection Point: [A]: A
						goto FCC_InsertMode_A;


					}


				}


			}


		} else {
			//Break key ?
			//Decision: brk_key?
			if (FCV_BRK_KEY)
			{
			} else {
				//Function or Windows keys ?
				//Decision: ASCII>0x09 AND ASCII<0x1B?
				if (FCV_ASCII>0x09 & FCV_ASCII<0x1B)
				{
				} else {
					//Misc TAB, RETN, ect.?
					//Decision: SCANcode=0x0D OR SCANcode=0x5A OR SCANcode=0x7E OR (SCANcode=0x1E AND CTRL)?
					if (FCV_SCANCODE==0x0D | FCV_SCANCODE==0x5A | FCV_SCANCODE==0x7E | (FCV_SCANCODE==0x1E & FCV_CTRL))
					{
					} else {
						//Print Screen key?
						//Decision: ext_key AND SCANcode = 0x7C?
						if (FCV_EXT_KEY & FCV_SCANCODE == 0x7C)
						{
						} else {
							//Connection Point
							//Connection Point: [A]: A
FCC_InsertMode_A:
;


							//Comment:
							//Insert Mode Code
							//BEGINS HERE


							//Backspace ?
							//Decision: SCANcode=0x66?
							if (FCV_SCANCODE==0x66)
							{
								//Rub-Out Character
								//Call Macro: StringSend("<")
								FCM_StringSend("<");


							} else {
								//Comment:
								//Insert one space for
								//incoming key to fill


								//
								//Calculation:
								//  POKEcode = 0x48
								//  InsertMode.temp = NOshift
								FCV_POKECODE = 0x48;
								FCL_TEMP = FCV_NOSHIFT;
								

								//Send key to POKEY
								//Call Macro: KeySend2
								FCM_KeySend2();


								//Restore State
								//Calculation:
								//  NOshift = InsertMode.temp
								FCV_NOSHIFT = FCL_TEMP;
								

								//Comment:
								//Let it Process


								//Delay
								//Delay: 5 ms
								delay_ms(5);


							}


							//
							//Calculation:
							//  Nonkey = 1
							FCV_NONKEY = 1;
							

						}


					}


				}


			}


		}


	}


}

void FCM_KeyProc()
{
	//This routine performs linitial processing of keyboard scan codes previously stored in ring buffer, by GetKey IRQ routine.
	
	//Key Data in Buffer ?
	//Decision: KBindxO<>KBindxI?
	if (FCV_KBINDXO!=FCV_KBINDXI)
	{
		//Comment:
		//Get next key out
		//of key buffer


		//Disable GetKey Interrupt
		//Interrupt: Disable RB0INT
		cr_bit(intcon, INTE);


		//Top of Buffer ?
		//Decision: KBindxO = 20?
		if (FCV_KBINDXO == 20)
		{
			//Reset to beginning
			//Calculation:
			//  KBindxO = 0
			FCV_KBINDXO = 0;
			

		}


		//Retrieve key from Buffer
		//Calculation:
		//  SCANcode = KBbuf[KBindxO]
		//  KBindxO = KBindxO+1
		FCV_SCANCODE = FCV_KBBUF[FCV_KBINDXO];
		FCV_KBINDXO = FCV_KBINDXO+1;
		

		//Enable GetKey IRQ
		//Interrupt: Enable RB0INT
		cr_bit(option_reg,INTEDG);
		st_bit(intcon,GIE);
		st_bit(intcon, INTE);


		//A8_ISO Mapping ?
		//Decision: KeyMap=3?
		if (FCV_KEYMAP==3)
		{
			//Control Key ?
			//Decision: SCANcode=0x14?
			if (FCV_SCANCODE==0x14)
			{
				//Extended ?
				//Decision: ext_key?
				if (FCV_EXT_KEY)
				{
					//Comment:
					//Right Control Key


					//Swap with Caps Key
					//Calculation:
					//  SCANcode = 0x58
					FCV_SCANCODE = 0x58;
					

				}


			} else {
				//Caps Lock Key ?
				//Decision: SCANcode=0x58?
				if (FCV_SCANCODE==0x58)
				{
					//Swap with Left Control Key
					//Calculation:
					//  SCANcode = 0x14
					FCV_SCANCODE = 0x14;
					

				}


			}


		}


		//Pause/Break key?
		//Decision: SCANcode = 0xE1?
		if (FCV_SCANCODE == 0xE1)
		{
			//
			//Calculation:
			//  brk_bytes = 5
			FCV_BRK_BYTES = 5;
			

		} else {
			//Processing Pause/Break key ?
			//Decision: brk_bytes>0?
			if (FCV_BRK_BYTES>0)
			{
			} else {
				//Extended key ?
				//Decision: SCANcode = 0xE0?
				if (FCV_SCANCODE == 0xE0)
				{
					//
					//Calculation:
					//  ext_key = 1
					FCV_EXT_KEY = 1;
					

				} else {
					//Release key ? 
					//Decision: SCANcode = 0xF0?
					if (FCV_SCANCODE == 0xF0)
					{
						//
						//Calculation:
						//  rel_key = 1
						FCV_REL_KEY = 1;
						

					} else {
						//Release key 2nd BYTE ?
						//Decision: rel_key?
						if (FCV_REL_KEY)
						{
							//Shift key released ?
							//Decision: SCANcode=0x12 OR SCANcode=0x59?
							if (FCV_SCANCODE==0x12 | FCV_SCANCODE==0x59)
							{
								//Numlock OFF and Extended ?
								//Decision: NOT NUMlock AND ext_key?
								if (~ FCV_NUMLOCK & FCV_EXT_KEY)
								{
									//Comment:
									//This is a false SHIFT
									//release generated by an
									//extended key when Numlock
									//is OFF (ignore it).


								} else {
									//
									//Calculation:
									//  SHIFT = 0
									//  shf_key = 0
									FCV_SHIFT = 0;
									FCV_SHF_KEY = 0;
									

									//SHIFT+RESET ?
									//Decision: rst_key OR shf_only?
									if (FCV_RST_KEY | FCV_SHF_ONLY)
									{
										//Clear Key
										//Calculation:
										//  SCANcode = 0
										//  shf_only = 0
										//  Nonkey = 1
										FCV_SCANCODE = 0;
										FCV_SHF_ONLY = 0;
										FCV_NONKEY = 1;
										

									}


								}


							}


							//Control key released ?
							//Decision: SCANcode=0x14?
							if (FCV_SCANCODE==0x14)
							{
								//
								//Calculation:
								//  CTRL = 0
								//  ctl_key = 0
								FCV_CTRL = 0;
								FCV_CTL_KEY = 0;
								

								//CTRL+RESET ?
								//Decision: rst_key?
								if (FCV_RST_KEY)
								{
									//Clear Key
									//Calculation:
									//  SCANcode = 0
									FCV_SCANCODE = 0;
									

								}


							}


							//Alt key released ?
							//Decision: SCANcode=0x11?
							if (FCV_SCANCODE==0x11)
							{
								//Extended ?
								//Decision: ext_key?
								if (FCV_EXT_KEY)
								{
									//German
									//Decision: KeyMap=1?
									if (FCV_KEYMAP==1)
									{
										//
										//Calculation:
										//  ALTgr = 0
										FCV_ALTGR = 0;
										

									} else {
										//Right ALT key
										//Calculation:
										//  ALT = 0
										FCV_ALT = 0;
										

									}


								} else {
									//Left ALT key
									//Calculation:
									//  ALT = 0
									FCV_ALT = 0;
									

								}


							}


							//F5 key ?
							//Decision: SCANcode = 0x03?
							if (FCV_SCANCODE == 0x03)
							{
								//Input (Float START)
								//Input: B4 -> temp
								trisb = trisb | 0x10;
								FCV_TEMP = ((portb & 0x10) == 0x10);


								//Clear Console Flag
								//Calculation:
								//  Console = 0
								FCV_CONSOLE = 0;
								

							}


							//F6 key ?
							//Decision: SCANcode = 0x0B?
							if (FCV_SCANCODE == 0x0B)
							{
								//Input (Float SELECT)
								//Input: B5 -> temp
								trisb = trisb | 0x20;
								FCV_TEMP = ((portb & 0x20) == 0x20);


								//Clear Console Flag
								//Calculation:
								//  Console = 0
								FCV_CONSOLE = 0;
								

							}


							//F7 key ?
							//Decision: SCANcode = 0x83?
							if (FCV_SCANCODE == 0x83)
							{
								//Input (Float OPTION)
								//Input: B6 -> temp
								trisb = trisb | 0x40;
								FCV_TEMP = ((portb & 0x40) == 0x40);


								//Clear Console Flag
								//Calculation:
								//  Console = 0
								FCV_CONSOLE = 0;
								

							}


							//F8 key ?
							//Decision: SCANcode = 0x0A?
							if (FCV_SCANCODE == 0x0A)
							{
								//Input (Float RESET)
								//Input: B7 -> temp
								trisb = trisb | 0x80;
								FCV_TEMP = ((portb & 0x80) == 0x80);


								//CTRL OR SHIFT + RESET ?
								//Decision: CTRL OR SHIFT?
								if (FCV_CTRL | FCV_SHIFT)
								{
								} else {
									//Clear Reset Flag
									//Calculation:
									//  rst_key = 0
									FCV_RST_KEY = 0;
									

								}


							}


							//
							//Calculation:
							//  rel_key = 0
							//  ext_key = 0
							FCV_REL_KEY = 0;
							FCV_EXT_KEY = 0;
							

						} else {
							//Flag as good key
							//Calculation:
							//  ok = 1
							FCV_OK = 1;
							

							//Extended key 2nd BYTE ?
							//Decision: ext_key?
							if (FCV_EXT_KEY)
							{
								//Extended Shift key down ?
								//Decision: SCANcode=0x12 OR SCANcode=0x59?
								if (FCV_SCANCODE==0x12 | FCV_SCANCODE==0x59)
								{
									//Comment:
									//This is a false SHIFT
									//down generated by an
									//extended key when Numlock
									//is OFF (ignore it).


									//
									//Calculation:
									//  ext_key = 0
									//  ok = 0
									FCV_EXT_KEY = 0;
									FCV_OK = 0;
									

								}


								//Right ALT key down ?
								//Decision: SCANcode=0x11?
								if (FCV_SCANCODE==0x11)
								{
									//German KeyMap ?
									//Decision: KeyMap=1?
									if (FCV_KEYMAP==1)
									{
										//
										//Calculation:
										//  ALTgr = 1
										FCV_ALTGR = 1;
										

									} else {
										//
										//Calculation:
										//  ALT = 1
										FCV_ALT = 1;
										

									}


									//Clear Key
									//Calculation:
									//  SCANcode = 0
									FCV_SCANCODE = 0;
									

								}


							} else {
								//Shift key down ?
								//Decision: SCANcode=0x12 OR SCANcode=0x59?
								if (FCV_SCANCODE==0x12 | FCV_SCANCODE==0x59)
								{
									//
									//Calculation:
									//  SHIFT = 1
									FCV_SHIFT = 1;
									

									//Clear Key
									//Calculation:
									//  SCANcode = 0
									FCV_SCANCODE = 0;
									

								}


								//Left Alt key down ?
								//Decision: SCANcode=0x11?
								if (FCV_SCANCODE==0x11)
								{
									//
									//Calculation:
									//  ALT = 1
									FCV_ALT = 1;
									

									//Clear Key
									//Calculation:
									//  SCANcode = 0
									FCV_SCANCODE = 0;
									

								}


							}


							//Control key down ?
							//Decision: SCANcode=0x14?
							if (FCV_SCANCODE==0x14)
							{
								//
								//Calculation:
								//  CTRL = 1
								FCV_CTRL = 1;
								

								//Clear Key
								//Calculation:
								//  SCANcode = 0
								FCV_SCANCODE = 0;
								

							}


							//F5 key ?
							//Decision: SCANcode = 0x03 AND NOT ALT?
							if (FCV_SCANCODE == 0x03 & ~ FCV_ALT)
							{
								//Output (START)
								//Output: 0 -> B4
								trisb = trisb & 0xef;
								if (0)
									portb = (portb & 0xef) | 0x10;
								else
									portb = portb & 0xef;


								//See if key down
								//Call Macro: KeyDownCHK
								FCM_KeyDownCHK();


								//Flag Console Key Pressed
								//Calculation:
								//  Console = 1
								FCV_CONSOLE = 1;
								

							}


							//F6 key ?
							//Decision: SCANcode = 0x0B AND NOT ALT?
							if (FCV_SCANCODE == 0x0B & ~ FCV_ALT)
							{
								//Output (SELECT)
								//Output: 0 -> B5
								trisb = trisb & 0xdf;
								if (0)
									portb = (portb & 0xdf) | 0x20;
								else
									portb = portb & 0xdf;


								//See if key down
								//Call Macro: KeyDownCHK
								FCM_KeyDownCHK();


								//Flag Console Key Pressed
								//Calculation:
								//  Console = 1
								FCV_CONSOLE = 1;
								

							}


							//F7 key ?
							//Decision: SCANcode = 0x83 AND NOT ALT?
							if (FCV_SCANCODE == 0x83 & ~ FCV_ALT)
							{
								//Output (OPTION)
								//Output: 0 -> B6
								trisb = trisb & 0xbf;
								if (0)
									portb = (portb & 0xbf) | 0x40;
								else
									portb = portb & 0xbf;


								//See if key down
								//Call Macro: KeyDownCHK
								FCM_KeyDownCHK();


								//Flag Console Key Pressed
								//Calculation:
								//  Console = 1
								FCV_CONSOLE = 1;
								

							}


							//F8 key ?
							//Decision: SCANcode = 0x0A AND NOT ALT?
							if (FCV_SCANCODE == 0x0A & ~ FCV_ALT)
							{
								//Output (RESET)
								//Output: 0 -> B7
								trisb = trisb & 0x7f;
								if (0)
									portb = (portb & 0x7f) | 0x80;
								else
									portb = portb & 0x7f;


								//
								//Calculation:
								//  rst_key = 1
								FCV_RST_KEY = 1;
								

								//See if key down
								//Call Macro: KeyDownCHK
								FCM_KeyDownCHK();


							}


						}


					}


				}


			}


		}


		//Comment:
		//If Break was detected
		//there will be a few bytes
		//that need to clear
		//before it's done.


		//Break key still busy ?
		//Decision: brk_bytes>0?
		if (FCV_BRK_BYTES>0)
		{
			//count down
			//Calculation:
			//  brk_bytes = brk_bytes-1
			//  ok = 0
			FCV_BRK_BYTES = FCV_BRK_BYTES-1;
			FCV_OK = 0;
			

			//Break key last byte ?
			//Decision: brk_bytes=1?
			if (FCV_BRK_BYTES==1)
			{
				//Prepare to send Break
				//Calculation:
				//  brk_key = 0x0F
				//  POKEcode = 0x36
				//  POKEen = 1
				//  Nonkey = 1
				FCV_BRK_KEY = 0x0F;
				FCV_POKECODE = 0x36;
				FCV_POKEEN = 1;
				FCV_NONKEY = 1;
				

			}


		}


	} else {
		//Comment:
		//Key buffer is empty,
		//so no new keys are
		//ready to be processed.
		//Leave for now.


	}


}

void FCM_ModEncode()
{
	//Modifys POKEcode bits 6 and 7 if certain Shift and Control states are in effect.
	
	//Comment:
	//Encode Shift and Control
	//bits into key code byte.
	//Bit-7 = Shift, Bit-6 = Control


	//Comment:
	//                    POKEY SCAN
	//SHF CTL  - matrix key code -
	//  7   |  6  |  5 |  4 |  3 |  2 |  1 |  0
	// 


	//Disallow Mod keys ?
	//Decision: POKEcode=0x36 OR SCANcode=0x69 OR SCANcode=0x6C OR SCANcode=0x7A OR SCANcode=0x7C OR SCANcode=0x7D OR (( SCANcode>0x6A AND SCANcode<0x7D) AND NOT ext_key AND NOT SCANcode=0x76 AND NOT SCANcode=0x78)?
	if (FCV_POKECODE==0x36 | FCV_SCANCODE==0x69 | FCV_SCANCODE==0x6C | FCV_SCANCODE==0x7A | FCV_SCANCODE==0x7C | FCV_SCANCODE==0x7D | (( FCV_SCANCODE>0x6A & FCV_SCANCODE<0x7D) & ~ FCV_EXT_KEY & ~ FCV_SCANCODE==0x76 & ~ FCV_SCANCODE==0x78))
	{
	} else {
		//Caps ?
		//Decision: CAPS?
		if (FCV_CAPS)
		{
			//Controlled ?
			//Decision: CTRL?
			if (FCV_CTRL)
			{
				//SHIFT key ?
				//Decision: SHIFT?
				if (FCV_SHIFT)
				{
					//Add both CTRL + SHIFT
					//Calculation:
					//  temp = SHIFT <<7
					//  temp = temp OR CTRL <<6
					//  POKEcode = temp OR POKEcode
					FCV_TEMP = FCV_SHIFT <<7;
					FCV_TEMP = FCV_TEMP | FCV_CTRL <<6;
					FCV_POKECODE = FCV_TEMP | FCV_POKECODE;
					

				} else {
					//Strip out SHIFT bit
					//Calculation:
					//  POKEcode = POKEcode AND 0x7F
					FCV_POKECODE = FCV_POKECODE & 0x7F;
					

				}


			}


		}


		//Special Circumstances ?
		//Decision: (CAPS=SHIFT OR (CTRL AND NOT SHIFT) OR NOshift) AND SCANcode<>0x0D AND SCANcode<>0x5A AND SCANcode<>0x66 AND SCANcode<>0x7C AND SCANcode<>0x1F AND SCANcode<>0x27 AND SCANcode<>0x2F AND SCANcode<>0x04 AND SCANcode<>0x05 AND SCANcode<>0x06 AND SCANcode<>0x0C AND SCANcode<>0x76 AND SCANcode<>0x0E AND SCANcode<>0x09 AND SCANcode<>0x78?
		if ((FCV_CAPS==FCV_SHIFT | (FCV_CTRL & ~ FCV_SHIFT) | FCV_NOSHIFT) & FCV_SCANCODE!=0x0D & FCV_SCANCODE!=0x5A & FCV_SCANCODE!=0x66 & FCV_SCANCODE!=0x7C & FCV_SCANCODE!=0x1F & FCV_SCANCODE!=0x27 & FCV_SCANCODE!=0x2F & FCV_SCANCODE!=0x04 & FCV_SCANCODE!=0x05 & FCV_SCANCODE!=0x06 & FCV_SCANCODE!=0x0C & FCV_SCANCODE!=0x76 & FCV_SCANCODE!=0x0E & FCV_SCANCODE!=0x09 & FCV_SCANCODE!=0x78)
		{
			//Comment:
			//If Both Shift and CAPS,
			//or any other designated
			//NOshift key, then do not
			//set SHIFT Bit.


			//Add CTRL bit only
			//Calculation:
			//  temp = CTRL <<6
			//  POKEcode = POKEcode OR temp
			FCV_TEMP = FCV_CTRL <<6;
			FCV_POKECODE = FCV_POKECODE | FCV_TEMP;
			

		} else {
			//Add both CTRL and SHIFT
			//Calculation:
			//  temp = SHIFT <<7
			//  temp = temp OR CTRL <<6
			//  POKEcode = temp OR POKEcode
			FCV_TEMP = FCV_SHIFT <<7;
			FCV_TEMP = FCV_TEMP | FCV_CTRL <<6;
			FCV_POKECODE = FCV_TEMP | FCV_POKECODE;
			

		}


		//Extended key ?
		//Decision: ext_key?
		if (FCV_EXT_KEY)
		{
			//Shifted ?
			//Decision: SHIFT?
			if (FCV_SHIFT)
			{
				//Controlled?
				//Decision: CTRL?
				if (FCV_CTRL)
				{
				} else {
					//Ext "/" key ?
					//Decision: SCANcode=0x4A?
					if (FCV_SCANCODE==0x4A)
					{
						//Strip out SHIFT bit
						//Calculation:
						//  POKEcode = POKEcode AND 0x7F
						FCV_POKECODE = FCV_POKECODE & 0x7F;
						

					} else {
						//Strip CTRL add Shift
						//Calculation:
						//  POKEcode = POKEcode OR 0x80
						//  POKEcode = POKEcode AND 0xBF
						FCV_POKECODE = FCV_POKECODE | 0x80;
						FCV_POKECODE = FCV_POKECODE & 0xBF;
						

					}


				}


			}


		}


	}


}

void FCM_StringSend(char* PFCL_TEXT)
{
	//This routine converts an ASCII text string into its POKEcode equivalent and then prints it character by character on screen. There are also some embedded print control codes that will perform special operations.
	
	#define FC_STRINGSEND_SZ_TEXT 41
	char FCL_TEXT[FC_STRINGSEND_SZ_TEXT];
	FCI_CONCATENATE(PFCL_TEXT,FC_STRINGSEND_SZ_TEXT,"",0,FCL_TEXT,FC_STRINGSEND_SZ_TEXT);
	//Clear for DoubleKey
	//Calculation:
	//  POKEtemp = 0xFD
	FCV_POKETEMP = 0xFD;
	

	//Get text string size
	//String Manipulation:
	//  size = Length$(StringSend.text)
	FCV_SIZE = FCI_GETLENGTH(FCL_TEXT,FC_STRINGSEND_SZ_TEXT);
	

	//
	//Calculation:
	//  ADDRtemp = size
	//  ADDRptr = 0
	FCV_ADDRTEMP = FCV_SIZE;
	FCV_ADDRPTR = 0;
	

	//Recall Loop
	//Loop: While ADDRptr=ADDRtemp
	while (!(FCV_ADDRPTR==FCV_ADDRTEMP))
	{
		//Start parsing text string
		//String Manipulation:
		//  ASCII = Char$(StringSend.text, ADDRptr)
		FCV_ASCII = FCI_GETCHAR(FCL_TEXT,FC_STRINGSEND_SZ_TEXT,FCV_ADDRPTR);
		

		//Clear Screen (GRAVE) ?
		//Decision: ASCII =0x60?
		if (FCV_ASCII ==0x60)
		{
			//Is this a List ?
			//Decision: List?
			if (FCV_LIST)
			{
				//Use Line Break Method ?
				//Decision: MenuB?
				if (FCV_MENUB)
				{
					//Do Break
					//Calculation:
					//  ASCII = 0x13
					//  brk_key = 0x0F
					FCV_ASCII = 0x13;
					FCV_BRK_KEY = 0x0F;
					

					//Do Separator
					//Calculation:
					//  POKEcode = 0xFD
					FCV_POKECODE = 0xFD;
					

					//Send It
					//Call Macro: KeySend2
					FCM_KeySend2();


					//Do Down Arrow
					//Calculation:
					//  POKEcode = 0x70
					FCV_POKECODE = 0x70;
					

					//Send It
					//Call Macro: KeySend2
					FCM_KeySend2();


				} else {
					//Do Home
					//Calculation:
					//  ASCII = 0x13
					//  POKEcode = 0xAC
					FCV_ASCII = 0x13;
					FCV_POKECODE = 0xAC;
					

					//Send It
					//Call Macro: KeySend2
					FCM_KeySend2();


					//Do Down Arrow
					//Calculation:
					//  POKEcode = 0x70
					FCV_POKECODE = 0x70;
					

					//Send It
					//Call Macro: KeySend2
					FCM_KeySend2();


					//Do F2 Down Arrow
					//Calculation:
					//  POKEcode = 0x3B
					FCV_POKECODE = 0x3B;
					

					//Send It
					//Call Macro: KeySend2
					FCM_KeySend2();


				}


			} else {
				//Do Clear Screen
				//Calculation:
				//  ASCII = 0x16
				FCV_ASCII = 0x16;
				

			}


		}


		//Break (TILDE) ?
		//Decision: ASCII =0x7E?
		if (FCV_ASCII ==0x7E)
		{
			//Is this a List ?
			//Decision: List?
			if (FCV_LIST)
			{
				//Do TAB
				//Calculation:
				//  ASCII = 0x09
				FCV_ASCII = 0x09;
				

			} else {
				//Do Home
				//Calculation:
				//  ASCII = 0x13
				//  POKEcode = 0xAC
				FCV_ASCII = 0x13;
				FCV_POKECODE = 0xAC;
				

				//Send It
				//Call Macro: KeySend2
				FCM_KeySend2();


				//Do Down Arrow
				//Calculation:
				//  POKEcode = 0x70
				FCV_POKECODE = 0x70;
				

				//Send It
				//Call Macro: KeySend2
				FCM_KeySend2();


			}


		}


		//TAB >
		//Decision: ASCII=0x3E?
		if (FCV_ASCII==0x3E)
		{
			//Is this a List ?
			//Decision: List?
			if (FCV_LIST)
			{
				//Do TAB
				//Calculation:
				//  ASCII = 0x09
				FCV_ASCII = 0x09;
				

			} else {
				//Do Space
				//Calculation:
				//  ASCII = 0x20
				FCV_ASCII = 0x20;
				

			}


		}


		//Rub-Out <
		//Decision: ASCII=0x3C?
		if (FCV_ASCII==0x3C)
		{
			//Do Back Space
			//Calculation:
			//  ASCII = 0x13
			//  POKEcode = 0x0B
			FCV_ASCII = 0x13;
			FCV_POKECODE = 0x0B;
			

			//Send it
			//Call Macro: KeySend2
			FCM_KeySend2();


			//Comment:
			//Let it Process


			//Delay
			//Delay: 5 ms
			delay_ms(5);


			//Do Delete
			//Calculation:
			//  POKEcode = 0x4B
			FCV_POKECODE = 0x4B;
			

			//Send it
			//Call Macro: KeySend2
			FCM_KeySend2();


		}


		//Return |
		//Decision: ASCII=0x7C?
		if (FCV_ASCII==0x7C)
		{
			//Do Return
			//Calculation:
			//  ASCII = 0x0D
			FCV_ASCII = 0x0D;
			

		}


		//Left Arrow {
		//Decision: ASCII=0x7B?
		if (FCV_ASCII==0x7B)
		{
			//Do Return
			//Calculation:
			//  ASCII = 0x1C
			FCV_ASCII = 0x1C;
			

		}


		//Right Arrow }
		//Decision: ASCII=0x7D?
		if (FCV_ASCII==0x7D)
		{
			//Do Return
			//Calculation:
			//  ASCII = 0x1D
			FCV_ASCII = 0x1D;
			

		}


		//Comment:
		//ASCII-TO-POKEY LUT
		//Translate ASCII into POKEY
		//scan matrix key codes.


		//Translate
		//Call Macro: Ascii2Pokey
		FCM_Ascii2Pokey();


		//Check for 2 keys the same
		//Call Macro: DoubleKey
		FCM_DoubleKey();


		//Send Key
		//Call Macro: KeySend2
		FCM_KeySend2();


		//Prepare for next key
		//Calculation:
		//  POKEtemp = POKEcode
		//  ADDRptr = ADDRptr+1
		FCV_POKETEMP = FCV_POKECODE;
		FCV_ADDRPTR = FCV_ADDRPTR+1;
		

	}


	//
	//Calculation:
	//  POKEcode = 0x36
	//  SCANold = 0
	//  ASCII = 0
	//  Nonkey = 1
	FCV_POKECODE = 0x36;
	FCV_SCANOLD = 0;
	FCV_ASCII = 0;
	FCV_NONKEY = 1;
	

}

void FCM_Ascii2Pokey()
{
	//Translates ASCII coded characters to POKEcode keys.
	
	//C Code
	//C Code:
	/*  Translate ASCII to POKEY keycode*/

	rom char* pokey_tbl =
		{
		0x36,0x48,0x4B,0xAC,0xAB,0xBC,0xBB,0x60,
		0x0B,0x13,0x04,0x04,0x0E,0x33,0x36,0x3C,
		0x3B,0x2C,0x2B,0x36,0x88,0x8B,0x89,0x36,
		0x2E,0x36,0x2E,0x23,0x79,0x78,0x71,0x70,
		0x1E,0xA0,0xA1,0xA5,0xA7,0xA2,0xA4,0x8C,
		0x8F,0x8D,0x38,0x39,0x1F,0x31,0x1D,0x19,
		0x0D,0x20,0x21,0x25,0x27,0x22,0x24,0x0C,
		0x0A,0x0F,0xBD,0x3D,0x09,0x30,0x08,0x99,
		0x8A,0x80,0xAA,0xAD,0x85,0x95,0x87,0x82,
		0x86,0xB2,0xBE,0xBA,0xBF,0x9A,0x9C,0xB7,
		0xB5,0x90,0x97,0x81,0x92,0xB4,0xAF,0x91,
		0xA9,0x94,0xA8,0x9F,0xB9,0x9D,0xB8,0xB1,
		0x18,0x00,0x2A,0x2D,0x05,0x15,0x07,0x02,
		0x06,0x32,0x3E,0x3A,0x3F,0x1A,0x1C,0x37,
		0x35,0x10,0x17,0x01,0x12,0x34,0x2F,0x11,
		0x29,0x14,0x28,0x45,0xB0,0x40,0xB8,0x8B
	    };

	FCV_POKECODE=pokey_tbl[FCV_ASCII];


}

void FCM_KeyMacros()
{
	//A place where hard coded ALT+key macros reside.
	
	//B key ?
	//Decision: SCANcode=0x32?
	if (FCV_SCANCODE==0x32)
	{
		//BASIC
		//Call Macro: StringSend("`BASIC|")
		FCM_StringSend("`BASIC|");


	}


	//C key ?
	//Decision: SCANcode=0x21?
	if (FCV_SCANCODE==0x21)
	{
		//CAR
		//Call Macro: StringSend("`CAR|")
		FCM_StringSend("`CAR|");


	}


	//D key ?
	//Decision: SCANcode=0x23?
	if (FCV_SCANCODE==0x23)
	{
		//DOS
		//Call Macro: StringSend("`DOS|")
		FCM_StringSend("`DOS|");


	}


	//F key ?
	//Decision: SCANcode=0x2B?
	if (FCV_SCANCODE==0x2B)
	{
		//Free Memory
		//Call Macro: StringSend("`?FRE(0)|")
		FCM_StringSend("`?FRE(0)|");


	}


	//L key ?
	//Decision: SCANcode=0x4B?
	if (FCV_SCANCODE==0x4B)
	{
		//LIST
		//Call Macro: StringSend("`LIST|")
		FCM_StringSend("`LIST|");


	}


	//N key ?
	//Decision: SCANcode=0x31?
	if (FCV_SCANCODE==0x31)
	{
		//NEW
		//Call Macro: StringSend("`NEW|")
		FCM_StringSend("`NEW|");


	}


	//R key ?
	//Decision: SCANcode=0x2D?
	if (FCV_SCANCODE==0x2D)
	{
		//RUN
		//Call Macro: StringSend("`RUN|")
		FCM_StringSend("`RUN|");


	}


	//F1 key ?
	//Decision: SCANcode = 0x05?
	if (FCV_SCANCODE == 0x05)
	{
		//Model/Ver #
		//Call Macro: StringSend("`1.9X~")
		FCM_StringSend("`1.9X~");


	}


	//F2 or F3 key ?
	//Decision: SCANcode = 0x06 OR SCANcode = 0x04?
	if (FCV_SCANCODE == 0x06 | FCV_SCANCODE == 0x04)
	{
		//F3 Key ?
		//Decision: SCANcode = 0x04?
		if (FCV_SCANCODE == 0x04)
		{
			//Set Flag
			//Calculation:
			//  MenuB = 1
			FCV_MENUB = 1;
			

		} else {
			//Clear Flag
			//Calculation:
			//  MenuB = 0
			FCV_MENUB = 0;
			

		}


		//Display Header
		//Call Macro: StringSend("`_ _ _ _ _ CURRENT SETTINGS _ _ _ _ _~")
		FCM_StringSend("`_ _ _ _ _ CURRENT SETTINGS _ _ _ _ _~");


		//
		//Calculation:
		//  temp = 0
		//  List = 1
		FCV_TEMP = 0;
		FCV_LIST = 1;
		

		//Display Legend
		//Call Macro: StringSend("`  FUNCTION> SET>   TOGGLE~")
		FCM_StringSend("`  FUNCTION> SET>   TOGGLE~");


		//Loop
		//Loop: While temp=9
		while (1)
		{
			//List Each Config Setting
			//Call Macro: ConfigRead(temp, 1)
			FCM_ConfigRead(FCV_TEMP, 1);


			//Prefix not needed ?
			//Decision: temp=7?
			if (FCV_TEMP==7)
			{
			} else {
				//Comment:
				//Display Prefix
				//prior to Hot Key


				//"CTRL+ALT+"
				//Call Macro: StringSend(" CTRL+ALT+")
				FCM_StringSend(" CTRL+ALT+");


			}


			//Display Hot Key
			//Switch: temp?
			switch (FCV_TEMP)
			{
				case 1:
				{
					//Hot Key
					//Call Macro: StringSend("S")
					FCM_StringSend("S");


					break;
				}

				case 2:
				{
					//Hot Key
					//Call Macro: StringSend("X")
					FCM_StringSend("X");


					break;
				}

				case 3:
				{
					//Hot Key
					//Call Macro: StringSend("F4")
					FCM_StringSend("F4");


					break;
				}

				case 4:
				{
					//Hot Key
					//Call Macro: StringSend("5")
					FCM_StringSend("5");


					break;
				}

				case 5:
				{
					//Hot Key
					//Call Macro: StringSend("G")
					FCM_StringSend("G");


					break;
				}

				case 6:
				{
					//Hot Key
					//Call Macro: StringSend("CAPS")
					FCM_StringSend("CAPS");


					break;
				}

				case 7:
				{
					//Hot Key
					//Call Macro: StringSend(" ALT+A")
					FCM_StringSend(" ALT+A");


					break;
				}

				case 8:
				{
					//Hot Key
					//Call Macro: StringSend("A")
					FCM_StringSend("A");


					break;
				}

				default:
				{
					//Hot Key
					//Call Macro: StringSend("O")
					FCM_StringSend("O");


				}
			}


			//
			//Calculation:
			//  temp = temp+1
			FCV_TEMP = FCV_TEMP+1;
			

			if ((FCV_TEMP==9) != 0) break;
		}


		//
		//Calculation:
		//  List = 0
		FCV_LIST = 0;
		

		//Do Break
		//Call Macro: StringSend("~")
		FCM_StringSend("~");


	}


}

void FCM_ClipBoard()
{
	//Macro ClipBoard uses CTRL+ALT+F5-F12 to record and ALT+F5-F12 for playback of  recorded keys. Pressing any of the 8 function keys with CTRL+ALT will stop the recording process, storing the result in the internal EEPROM. CTRL+ALT+Escape aborts.
	
	//CTRL+ALT+Escape ?
	//Decision: (CTRL AND ALT AND SCANcode=0x76) AND record>0?
	if ((FCV_CTRL & FCV_ALT & FCV_SCANCODE==0x76) & FCV_RECORD>0)
	{
		//Comment:
		//Abort record operation,
		//leaving previous record
		//intact.


		//Double Wiggle
		//Call Macro: WIggle(1)
		FCM_WIggle(1);


		//
		//Calculation:
		//  POKEcode = 0x36
		//  record = 0
		//  INSmode = INSmodeSave
		//  LED = (LED & 0x06) OR INSmode
		FCV_POKECODE = 0x36;
		FCV_RECORD = 0;
		FCV_INSMODE = FCV_INSMODESAVE;
		FCV_LED = (FCV_LED & 0x06) | FCV_INSMODE;
		

		//Reset Scroll LED
		//Call Macro: LEDupdate
		FCM_LEDupdate();


	} else {
		//Comment:
		//CTRL+ALT+F5-F12 Starts or
		//Stops Macro Recording.


		//CTRL+ALT+F5-F12 ?
		//Decision: CTRL AND ALT AND (ASCII>0x12 AND ASCII<0x1B)?
		if (FCV_CTRL & FCV_ALT & (FCV_ASCII>0x12 & FCV_ASCII<0x1B))
		{
			//In Record Mode ?
			//Decision: record>0?
			if (FCV_RECORD>0)
			{
				//Comment:
				//Transfer record buffer
				//contents to EEPROM


				//Get EEPROM Bank location
				//Calculation:
				//  ADDRbank = (record*32)-1
				FCV_ADDRBANK = (FCV_RECORD*32)-1;
				

				//Get Temporary Buffer Pointer
				//Calculation:
				//  ADDRptr = CLIPbuf[31]
				//  ADDRtemp = ADDRptr
				//  ADDRptr = 0
				//  record = 0
				FCV_ADDRPTR = FCV_CLIPBUF[31];
				FCV_ADDRTEMP = FCV_ADDRPTR;
				FCV_ADDRPTR = 0;
				FCV_RECORD = 0;
				

				//Transfer Loop
				//Loop: While ADDRptr=ADDRtemp
				while (!(FCV_ADDRPTR==FCV_ADDRTEMP))
				{
					//Get key from record buffer
					//Calculation:
					//  temp = (ADDRbank-31)+ADDRptr
					//  POKEcode = CLIPbuf[ADDRptr]
					FCV_TEMP = (FCV_ADDRBANK-31)+FCV_ADDRPTR;
					FCV_POKECODE = FCV_CLIPBUF[FCV_ADDRPTR];
					

					//Store key
					//Call Component Macro: EEPROM(0)::Write(temp, POKEcode)
					FCD_EEPROM0_WriteEEPROM(FCV_TEMP, FCV_POKECODE);


					//Increment Address
					//Calculation:
					//  ADDRptr = ADDRptr+1
					FCV_ADDRPTR = FCV_ADDRPTR+1;
					

				}


				//Store buffer size
				//Call Component Macro: EEPROM(0)::Write(ADDRbank, ADDRtemp)
				FCD_EEPROM0_WriteEEPROM(FCV_ADDRBANK, FCV_ADDRTEMP);


				//Double Wiggle
				//Call Macro: WIggle(1)
				FCM_WIggle(1);


				//
				//Calculation:
				//  INSmode = INSmodeSave
				//  LED = (LED & 0x06) OR INSmode
				FCV_INSMODE = FCV_INSMODESAVE;
				FCV_LED = (FCV_LED & 0x06) | FCV_INSMODE;
				

				//Reset Scroll LED
				//Call Macro: LEDupdate
				FCM_LEDupdate();


			} else {
				//Comment:
				//Set to Record Mode and
				//zero buffer pointer.
				//The "record" variable points
				//to the Macro to write.


				//Comment:
				//F5 = Macro 1 (record=1)
				//F6 = Macro 2 (record=2)
				//F7 = Macro 3 (record=3)
				//F8 = Macro 4 (record=4)


				//Comment:
				//F9   = Macro 5 (record=5)
				//F10 = Macro 6 (record=6)
				//F11 = Macro 7 (record=7)
				//F12 = Macro 8 (record=8)


				//
				//Calculation:
				//  record = ASCII-0x12
				//  CLIPbuf[31] = 0
				//  SCANcode = 0
				//  INSmodeSave = INSmode
				//  INSmode = 0
				//  LED = LED AND 0xFE
				FCV_RECORD = FCV_ASCII-0x12;
				FCV_CLIPBUF[31] = 0;
				FCV_SCANCODE = 0;
				FCV_INSMODESAVE = FCV_INSMODE;
				FCV_INSMODE = 0;
				FCV_LED = FCV_LED & 0xFE;
				

				//Scroll LED OFF
				//Call Macro: LEDupdate
				FCM_LEDupdate();


				//Single Wiggle
				//Call Macro: WIggle(0)
				FCM_WIggle(0);


			}


		} else {
			//ALT+F5-F12 ?
			//Decision: ALT AND (ASCII>0x12 AND ASCII<0x1B)?
			if (FCV_ALT & (FCV_ASCII>0x12 & FCV_ASCII<0x1B))
			{
				//Comment:
				//Playback from EEPROM


				//Clear for DoubleKey
				//Calculation:
				//  POKEtemp = 0xFD
				FCV_POKETEMP = 0xFD;
				

				//Get address of buffer size
				//Calculation:
				//  ADDRbank = ((ASCII-0x12)*32)-1
				FCV_ADDRBANK = ((FCV_ASCII-0x12)*32)-1;
				

				//Retrieve buffer size
				//Call Component Macro: ADDRptr=EEPROM(0)::Read(ADDRbank)
				FCV_ADDRPTR = FCD_EEPROM0_EEPROMRead(FCV_ADDRBANK);


				//Something in buffer ?
				//Decision: ADDRptr>0?
				if (FCV_ADDRPTR>0)
				{
					//Store size and zero pointer
					//Calculation:
					//  ADDRtemp = ADDRptr
					//  ADDRptr = 0
					FCV_ADDRTEMP = FCV_ADDRPTR;
					FCV_ADDRPTR = 0;
					

					//Recall Loop
					//Loop: While ADDRptr=ADDRtemp
					while (!(FCV_ADDRPTR==FCV_ADDRTEMP))
					{
						//Create EEPROM address
						//Calculation:
						//  temp = (ADDRbank-31)+ADDRptr
						FCV_TEMP = (FCV_ADDRBANK-31)+FCV_ADDRPTR;
						

						//Retreive key
						//Call Component Macro: POKEcode=EEPROM(0)::Read(temp)
						FCV_POKECODE = FCD_EEPROM0_EEPROMRead(FCV_TEMP);


						//Check for 2 keys the same
						//Call Macro: DoubleKey
						FCM_DoubleKey();


						//Detected Slow Send ?
						//Decision: slow?
						if (FCV_SLOW)
						{
							//Slow down transmission
							//Delay: 75 ms
							delay_ms(75);


						} else {
							//Comment:
							//Normal speed send


						}


						//Move to next key
						//Calculation:
						//  ADDRptr = ADDRptr+1
						FCV_ADDRPTR = FCV_ADDRPTR+1;
						

						//Speed Toggle ?
						//Decision: POKEcode=0x60?
						if (FCV_POKECODE==0x60)
						{
							//Comment:
							//Embedded CTRL+1 code
							//encountered, so toggle
							//flag that controls key
							//send delay.


							//
							//Calculation:
							//  slow = slow XOR 1
							FCV_SLOW = FCV_SLOW ^ 1;
							

							//Comment:
							//Bypassing key send routine
							//so CTRL 1 key not seen by
							//Atari.


						} else {
							//Pause ?
							//Decision: POKEcode=0x61 AND PrevKey<>0x23?
							if (FCV_POKECODE==0x61 & FCV_PREVKEY!=0x23)
							{
								//Comment:
								//Embedded CTRL+2 code
								//encountered, so do
								//Pause.


								//Create EEPROM address
								//Calculation:
								//  temp = (ADDRbank-31)+ADDRptr
								FCV_TEMP = (FCV_ADDRBANK-31)+FCV_ADDRPTR;
								

								//Retreive Next key
								//Call Component Macro: POKEcode=EEPROM(0)::Read(temp)
								FCV_POKECODE = FCD_EEPROM0_EEPROMRead(FCV_TEMP);


								//Out of Range ?
								//Decision: POKEcode<0x0A OR POKEcode>0x27?
								if (FCV_POKECODE<0x0A | FCV_POKECODE>0x27)
								{
									//Set to 1 SEC default
									//Calculation:
									//  POKEcode = 0x20
									FCV_POKECODE = 0x20;
									

								}


								//Create Offset
								//Calculation:
								//  POKEcode = POKEcode-0x0A
								FCV_POKECODE = FCV_POKECODE-0x0A;
								

								//Comment:
								//Translate POKEY keys 0-9
								//into actual 0-9 for
								//Pause value in seconds.


								//C Code
								//C Code:
								/*  Translate POKECODE to NUMBER 0-9*/

								rom char* num_tbl =
									{
									0x08,0x36,0x07,0x0A,0x36,0x09,0x36,0x36,
									0x36,0x36,0x36,0x36,0x36,0x36,0x36,0x36,
									0x36,0x36,0x36,0x36,0x36,0x36,0x01,0x02,
									0x05,0x36,0x06,0x03,0x36,0x04
								    };

								FCV_NUM=num_tbl[FCV_POKECODE];


								//Loop
								//Loop: While NUM
								while (1)
								{
									//Delay
									//Delay: 1 s
									delay_s(1);


									//
									//Calculation:
									//  NUM = NUM-1
									FCV_NUM = FCV_NUM-1;
									

									if ((FCV_NUM) == 0) break;
								}


								//Move to next key
								//Calculation:
								//  ADDRptr = ADDRptr+1
								FCV_ADDRPTR = FCV_ADDRPTR+1;
								

								//Comment:
								//Bypassing key send routine
								//so CTRL+2 key not seen by
								//Atari.


							} else {
								//In TK-II Caps Mode ?
								//Decision: TKcaps?
								if (FCV_TKCAPS)
								{
									//Comment:
									//If in Caps Lock,
									//add shift bit to
									//all alpha keys.


									//Shifted or Controlled ?
									//Decision: (POKEcode AND 0xC0)?
									if ((FCV_POKECODE & 0xC0))
									{
									} else {
										//Extract 6-Bit base code
										//Calculation:
										//  BASEcode = (POKEcode AND 0x3F)
										FCV_BASECODE = (FCV_POKECODE & 0x3F);
										

										//Comment:
										//Use LUT to convert
										//from raw POKEcode
										//into simple 0 or 1
										//Alpha Flag.


										//C Code
										//C Code:
										/*  Pokey alpha keycode truth table*/

										rom char* alpha_tbl =
											{
											1,1,1,0,0,1,1,1,
											0,0,0,0,0,0,0,0,
											1,1,1,0,1,1,0,1,
											0,0,1,0,1,0,0,0,
											0,0,0,0,0,0,0,0,
											1,1,1,0,0,1,0,1,
											0,0,1,0,1,1,0,1,
											0,0,1,0,0,0,1,1,
										    };

										FCV_ALPHA=alpha_tbl[FCV_BASECODE];


										//Alpha ?
										//Decision: alpha?
										if (FCV_ALPHA)
										{
											//Capitalize
											//Calculation:
											//  POKEcode = POKEcode OR (CAPS <<7)
											FCV_POKECODE = FCV_POKECODE | (FCV_CAPS <<7);
											

										}


									}


								}


								//Enable key send
								//Calculation:
								//  POKEtemp = POKEcode
								FCV_POKETEMP = FCV_POKECODE;
								

								//Send it
								//Call Macro: KeySend2
								FCM_KeySend2();


							}


						}


						//Copy Key
						//Calculation:
						//  PrevKey = POKEcode
						FCV_PREVKEY = FCV_POKECODE;
						

					}


				}


				//
				//Calculation:
				//  record = 0
				//  slow = 0
				//  POKEcode = 0x36
				//  SCANold = 0
				//  ASCII = 0
				//  Nonkey = 1
				FCV_RECORD = 0;
				FCV_SLOW = 0;
				FCV_POKECODE = 0x36;
				FCV_SCANOLD = 0;
				FCV_ASCII = 0;
				FCV_NONKEY = 1;
				

			} else {
				//Recording ?
				//Decision: record>0?
				if (FCV_RECORD>0)
				{
					//Disable Insert Mode
					//Calculation:
					//  INSmode = 0
					FCV_INSMODE = 0;
					

					//Non-Character ?
					//Decision: POKEcode=0x36?
					if (FCV_POKECODE==0x36)
					{
					} else {
						//Back Space ?
						//Decision: POKEcode=0x0B AND PrevKey<>0x23?
						if (FCV_POKECODE==0x0B & FCV_PREVKEY!=0x23)
						{
							//Are there keys in Buf ?
							//Decision: CLIPbuf[31]>0?
							if (FCV_CLIPBUF[31]>0)
							{
								//Remove one key
								//Calculation:
								//  CLIPbuf[31] = CLIPbuf[31]-1
								FCV_CLIPBUF[31] = FCV_CLIPBUF[31]-1;
								

							}


						} else {
							//Connection Point
							//Connection Point: [A]: A
FCC_ClipBoard_A:
;


							//Comment:
							//Record keys into
							//temporary buffer.


							//Retrieve Pointer
							//Calculation:
							//  ADDRptr = CLIPbuf[31]
							FCV_ADDRPTR = FCV_CLIPBUF[31];
							

							//Comment:
							//Limit Macro to 30
							//Keys.


							//Still have room ?
							//Decision: ADDRptr<30?
							if (FCV_ADDRPTR<30)
							{
								//Store Key
								//Calculation:
								//  CLIPbuf[ADDRptr] = POKEcode
								FCV_CLIPBUF[FCV_ADDRPTR] = FCV_POKECODE;
								

								//Increment Address
								//Calculation:
								//  ADDRptr = ADDRptr+1
								FCV_ADDRPTR = FCV_ADDRPTR+1;
								

								//Store Pointer
								//Calculation:
								//  CLIPbuf[31] = ADDRptr
								FCV_CLIPBUF[31] = FCV_ADDRPTR;
								

							} else {
								//Comment:
								//Make audible alert that
								//buffer space has been
								//exceeded, and exit.


								//End of Space Warning
								//Calculation:
								//  POKEcode = 0x61
								FCV_POKECODE = 0x61;
								

								//Goto Connection Point
								//Goto Connection Point: [B]: B
								goto FCC_ClipBoard_B;


							}


						}


					}


				}


				//Is this a non-printing key ?
				//Decision: SCANcode=0 AND brk_key<>0x0F?
				if (FCV_SCANCODE==0 & FCV_BRK_KEY!=0x0F)
				{
				} else {
					//Recording ?
					//Decision: record>0?
					if (FCV_RECORD>0)
					{
						//Comment:
						//Replacing Embedded
						//Commands with Symbols.


						//CTRL+1 ?
						//Decision: POKEcode=0x60?
						if (FCV_POKECODE==0x60)
						{
							//Comment:
							//Slow Send Toggle


							//Diamond Symbol
							//Calculation:
							//  POKEcode = 0x5D
							FCV_POKECODE = 0x5D;
							

						} else {
							//CTRL+2 ?
							//Decision: POKEcode=0x61 AND PrevKey<>0x23?
							if (FCV_POKECODE==0x61 & FCV_PREVKEY!=0x23)
							{
								//Comment:
								//1 SEC Pause (default)
								//Backspace/Replace
								//to change to 0-9,
								//with 0 = 10 Seconds.


								//Heart Symbol
								//Calculation:
								//  POKEcode = 0x5F
								//  POKEen = 1
								//  Nonkey = 1
								FCV_POKECODE = 0x5F;
								FCV_POKEEN = 1;
								FCV_NONKEY = 1;
								

								//Send it
								//Call Macro: KeySend
								FCM_KeySend();


								//Number 1
								//Calculation:
								//  POKEcode = 0x20
								FCV_POKECODE = 0x20;
								

								//Goto Connection Point
								//Goto Connection Point: [A]: A
								goto FCC_ClipBoard_A;


							} else {
								//Return ?
								//Decision: POKEcode=0x33?
								if (FCV_POKECODE==0x33)
								{
									//Medium Vert Line Symbol
									//Calculation:
									//  POKEcode = 0x6F
									FCV_POKECODE = 0x6F;
									

								} else {
									//TAB ?
									//Decision: POKEcode=0x13 AND PrevKey<>0x23?
									if (FCV_POKECODE==0x13 & FCV_PREVKEY!=0x23)
									{
										//Escape
										//Calculation:
										//  POKEcode = 0x23
										//  POKEen = 1
										//  Nonkey = 1
										FCV_POKECODE = 0x23;
										FCV_POKEEN = 1;
										FCV_NONKEY = 1;
										

										//Send it
										//Call Macro: KeySend
										FCM_KeySend();


										//Inverse Tab Symbol
										//Calculation:
										//  POKEcode = 0x48
										FCV_POKECODE = 0x48;
										

									}


								}


							}


						}


						//
						//Calculation:
						//  Nonkey = 1
						FCV_NONKEY = 1;
						

					}


					//Connection Point
					//Connection Point: [B]: B
FCC_ClipBoard_B:
;


					//Copy Key
					//Calculation:
					//  PrevKey = POKEcode
					//  temp2 = Nonkey
					FCV_PREVKEY = FCV_POKECODE;
					FCV_TEMP2 = FCV_NONKEY;
					

					//Is this an 'A' key ?
					//Decision: (POKEcode AND 0x3F)=0?
					if ((FCV_POKECODE & 0x3F)==0)
					{
						//Comment:
						//Skip DoubleKey routine if
						//'A' keys are repeating,
						//since it won't work in
						//this specific case.


					} else {
						//Check for 2 keys the same
						//Call Macro: DoubleKey
						FCM_DoubleKey();


						//Restore Nonkey State
						//Calculation:
						//  Nonkey = temp2
						FCV_NONKEY = FCV_TEMP2;
						

					}


					//Enable key send
					//Calculation:
					//  POKEen = 1
					//  POKEtemp = POKEcode
					FCV_POKEEN = 1;
					FCV_POKETEMP = FCV_POKECODE;
					

				}


				//Comment:
				//Here we drop through
				//to do normal POKEY
				//key send.


			}


		}


	}


}

void FCM_EEPROMinit()
{
	//This routine is only used once on a fresh PIC chip to insure that key memory locations in EEPROM hold valid data.
	
	//Set to 1st Bank
	//Calculation:
	//  ADDRbank = 31
	FCV_ADDRBANK = 31;
	

	//Loop
	//Loop: Loop 8 times
	for (FCLV_LOOP2=0; FCLV_LOOP2<8; FCLV_LOOP2++)
	{
		//Retrieve Bank Size
		//Call Component Macro: temp=EEPROM(0)::Read(ADDRbank)
		FCV_TEMP = FCD_EEPROM0_EEPROMRead(FCV_ADDRBANK);


		//New EEPROM ?
		//Decision: temp>30?
		if (FCV_TEMP>30)
		{
			//Zero buffer size
			//Call Component Macro: EEPROM(0)::Write(ADDRbank, 0)
			FCD_EEPROM0_WriteEEPROM(FCV_ADDRBANK, 0);


		}


		//Move to next Bank
		//Calculation:
		//  ADDRbank = ADDRbank + 32
		FCV_ADDRBANK = FCV_ADDRBANK + 32;
		

	}


}

void FCM_DoubleKey()
{
	//If two identical keys are to be sent back to back, as is the case for a macro, then a separator key is inserted inbetween to prevent POKEY from dropping keys.
	
	//Same character ?
	//Decision: (POKEcode AND 0x3F)=(POKEtemp AND 0x3F)?
	if ((FCV_POKECODE & 0x3F)==(FCV_POKETEMP & 0x3F))
	{
		//Save Original Key
		//Calculation:
		//  temp1 = POKEcode
		FCV_TEMP1 = FCV_POKECODE;
		

		//Comment:
		//The A8 treats CTRL+
		//SHIFT+A as a no-key
		//situation (keycd=255)
		//so we'll use this as... 


		//Comment:
		//an identical key press
		//separator.
		// 


		//Is this an 'A' key ?
		//Decision: (POKEcode AND 0x3F)=0?
		if ((FCV_POKECODE & 0x3F)==0)
		{
			//Comment:
			//Since the 'A' key and all
			//of it's normal CTRL or
			//SHIFT'ed variants share
			//the same 6-Bit basecode...


			//Comment:
			//we'll substitute a 64 mSec
			//delay between identical
			//keys so Pokey still sees
			//them as separate keys.


			//Loop
			//Loop: Loop 250 times
			for (FCLV_LOOP3=0; FCLV_LOOP3<250; FCLV_LOOP3++)
			{
				//Refresh Key Send
				//Call Macro: KeySend
				FCM_KeySend();


				//Delay
				//Delay: 230 us
				delay_us(230);


			}


		} else {
			//CTRL+SHIFT+ A
			//Calculation:
			//  POKEcode = 0xC0
			FCV_POKECODE = 0xC0;
			

		}


		//Comment:
		//Send the chosen separator
		//between identical key
		//presses to make each real
		//key look unique.


		//Send It
		//Call Macro: KeySend2
		FCM_KeySend2();


		//Restore Original Key
		//Calculation:
		//  POKEcode = temp1
		FCV_POKECODE = FCV_TEMP1;
		

	} else {
		//Comment:
		//Normal Send


	}


}

void FCM_CapsSync(char FCL_DELAY)
{
	//This routine is meant to automatically sync the caps lock state of the Atari to the Caps Lock action of the keyboard following either a Cold start or Reset. The delay before sending is set in 250ms increments using the Delay parameter.
	
	//1/4 Sec Delay
	//Delay: 500 ms
	delay_ms(255);
	delay_ms(245);


	//Input (Float RESET)
	//Input: B7 -> temp
	trisb = trisb | 0x80;
	FCV_TEMP = ((portb & 0x80) == 0x80);


	//Save LED state
	//Calculation:
	//  LEDsave = LED
	//  KEYscan = 0
	FCV_LEDSAVE = FCV_LED;
	FCV_KEYSCAN = 0;
	

	//Loop
	//Loop: While CapsSync.Delay
	while (FCL_DELAY)
	{
		//Clear Watch Dog Timer
		//C Code:
		clear_wdt();


		//
		//Calculation:
		//  LED = LED XOR 4
		FCV_LED = FCV_LED ^ 4;
		

		//Flash Caps LED
		//Call Macro: LEDupdate
		FCM_LEDupdate();


		//1/4 Sec Delay
		//Delay: 250 ms
		delay_ms(250);


		//Decrement Counter
		//Calculation:
		//  CapsSync.Delay = CapsSync.Delay-1
		FCL_DELAY = FCL_DELAY-1;
		

		//Underflow ?
		//Decision: CapsSync.Delay<0?
		if (FCL_DELAY<0)
		{
			//Reset Counter
			//Calculation:
			//  CapsSync.Delay = 0
			FCL_DELAY = 0;
			

		}


		//Key press aborts
		//Decision: KEYscan?
		if (FCV_KEYSCAN)
		{
			//Reset Counter
			//Calculation:
			//  CapsSync.Delay = 0
			FCL_DELAY = 0;
			

		}


	}


	//Restore LED state
	//Calculation:
	//  LED = LEDsave
	FCV_LED = FCV_LEDSAVE;
	

	//Update LED
	//Call Macro: LEDupdate
	FCM_LEDupdate();


	//Toggle ATARI Caps
	//Calculation:
	//  POKEcode = 0x03
	FCV_POKECODE = 0x03;
	

	//Send it
	//Call Macro: KeySend2
	FCM_KeySend2();


	//Input (Float RESET)
	//Input: B7 -> temp
	trisb = trisb | 0x80;
	FCV_TEMP = ((portb & 0x80) == 0x80);


	//Clean up
	//Calculation:
	//  rst_key = 0
	//  Nonkey = 1
	//  SHIFT = 0
	//  CTRL = 0
	//  ALT = 0
	//  ok = 0
	FCV_RST_KEY = 0;
	FCV_NONKEY = 1;
	FCV_SHIFT = 0;
	FCV_CTRL = 0;
	FCV_ALT = 0;
	FCV_OK = 0;
	

}

void FCM_PS2write(char FCL_DATA, char FCL_CHAN)
{
	//Host -to- Device communications routine. Channel parameter decides which device (0=keyboard #1, 1=keyboard #2), and the data parameter passes the byte you wish to have sent.
	
	//Local variable definitions
	char FCL_PARITY;

	//Initialize PARITY bit
	//Calculation:
	//  PS2write.parity = 1
	FCL_PARITY = 1;
	

	//Comment:
	//Let's initiate a com
	//request to the PS2 Device,
	//for Host-to-Device
	//Communications.


	//2nd Keyboard ?
	//Decision: PS2write.chan?
	if (FCL_CHAN)
	{
		//Pull clock line low
		//Output: 0 -> B2
		trisb = trisb & 0xfb;
		if (0)
			portb = (portb & 0xfb) | 0x04;
		else
			portb = portb & 0xfb;


	} else {
		//Pull clock line low
		//Output: 0 -> B0
		trisb = trisb & 0xfe;
		if (0)
			portb = (portb & 0xfe) | 0x01;
		else
			portb = portb & 0xfe;


	}


	//Delay
	//Delay: 150 us
	delay_us(150);


	//2nd Keyboard ?
	//Decision: PS2write.chan?
	if (FCL_CHAN)
	{
		//Pull data line low
		//Output: 0 -> B3
		trisb = trisb & 0xf7;
		if (0)
			portb = (portb & 0xf7) | 0x08;
		else
			portb = portb & 0xf7;


	} else {
		//Pull data line low
		//Output: 0 -> B1
		trisb = trisb & 0xfd;
		if (0)
			portb = (portb & 0xfd) | 0x02;
		else
			portb = portb & 0xfd;


	}


	//Delay
	//Delay: 25 us
	delay_us(25);


	//2nd Keyboard ?
	//Decision: PS2write.chan?
	if (FCL_CHAN)
	{
		//Release clock line
		//Input: B2 -> temp
		trisb = trisb | 0x04;
		FCV_TEMP = ((portb & 0x04) == 0x04);


	} else {
		//Release clock line
		//Input: B0 -> temp
		trisb = trisb | 0x01;
		FCV_TEMP = ((portb & 0x01) == 0x01);


	}


	//Comment:
	//We have now signaled the
	//PS2 Device that we are
	//ready to send data to it,
	//so let's send it!


	//Data Send Loop
	//Loop: Loop 8 times
	for (FCLV_LOOP4=0; FCLV_LOOP4<8; FCLV_LOOP4++)
	{
		//Send data bit
		//Call Macro: PS2sendBit(PS2write.data, PS2write.chan)
		FCM_PS2sendBit(FCL_DATA, FCL_CHAN);


		//Is this a one?
		//Decision: PS2write.data AND 0x01?
		if (FCL_DATA & 0x01)
		{
			//Add up total # of 1's
			//Calculation:
			//  PS2write.parity = PS2write.parity + 1
			FCL_PARITY = FCL_PARITY + 1;
			

		}


		//Shift out next bit
		//Calculation:
		//  PS2write.data = PS2write.data >>1
		FCL_DATA = FCL_DATA >>1;
		

	}


	//Comment:
	//Data has been sent,
	//just need to clean up
	//and exit.


	//Send PARITY bit
	//Call Macro: PS2sendBit(PS2write.parity, PS2write.chan)
	FCM_PS2sendBit(FCL_PARITY, FCL_CHAN);


	//Send STOP bit
	//Call Macro: PS2sendBit(1, PS2write.chan)
	FCM_PS2sendBit(1, FCL_CHAN);


	//2nd Keyboard ?
	//Decision: PS2write.chan?
	if (FCL_CHAN)
	{
		//Release data line
		//Input: B3 -> temp
		trisb = trisb | 0x08;
		FCV_TEMP = ((portb & 0x08) == 0x08);


	} else {
		//Release data line
		//Input: B1 -> temp
		trisb = trisb | 0x02;
		FCV_TEMP = ((portb & 0x02) == 0x02);


	}


	//Comment:
	//Wait for ACK bit to pass


	//Call Macro
	//Call Macro: PS2clkPos(PS2write.chan)
	FCM_PS2clkPos(FCL_CHAN);


}

void FCM_PS2clkPos(char FCL_CHAN)
{
	//Wait for PS2 clock to go low-to-high
	
	//Local variable definitions
	char FCL_CLK;

	//Reset TimeOut Counter
	//Calculation:
	//  TOcnt1 = 0
	FCV_TOCNT1 = 0;
	

	//Comment:
	//Wait for CLK low


	//Loop
	//Loop: While PS2clkPos.CLK = 1
	while (1)
	{
		//Check Elasped Time
		//Call Macro: PS2time
		FCM_PS2time();


		//Time Out ?
		//Decision: TOcnt1>TOmsSet?
		if (FCV_TOCNT1>FCV_TOMSSET)
		{
			//Goto Connection Point
			//Goto Connection Point: [A]: A
			goto FCC_PS2clkPos_A;


		}


		//2nd Keyboard ?
		//Decision: PS2clkPos.chan?
		if (FCL_CHAN)
		{
			//Input
			//Input: B2 -> PS2clkPos.CLK
			trisb = trisb | 0x04;
			FCL_CLK = ((portb & 0x04) == 0x04);


		} else {
			//Input
			//Input: B0 -> PS2clkPos.CLK
			trisb = trisb | 0x01;
			FCL_CLK = ((portb & 0x01) == 0x01);


		}


		if ((FCL_CLK == 1) == 0) break;
	}


	//Comment:
	//Wait for CLK hi


	//Loop
	//Loop: While PS2clkPos.CLK = 0
	while (1)
	{
		//Check Elasped Time
		//Call Macro: PS2time
		FCM_PS2time();


		//Time Out ?
		//Decision: TOcnt1>TOmsSet?
		if (FCV_TOCNT1>FCV_TOMSSET)
		{
			//Goto Connection Point
			//Goto Connection Point: [A]: A
			goto FCC_PS2clkPos_A;


		}


		//2nd Keyboard ?
		//Decision: PS2clkPos.chan?
		if (FCL_CHAN)
		{
			//Input
			//Input: B2 -> PS2clkPos.CLK
			trisb = trisb | 0x04;
			FCL_CLK = ((portb & 0x04) == 0x04);


		} else {
			//Input
			//Input: B0 -> PS2clkPos.CLK
			trisb = trisb | 0x01;
			FCL_CLK = ((portb & 0x01) == 0x01);


		}


		if ((FCL_CLK == 0) == 0) break;
	}


	//Connection Point
	//Connection Point: [A]: A
FCC_PS2clkPos_A:
;


	//Device Time Out ?
	//Decision: TOcnt1>TOmsSet?
	if (FCV_TOCNT1>FCV_TOMSSET)
	{
		//2nd Keyboard ?
		//Decision: PS2clkPos.chan?
		if (FCL_CHAN)
		{
			//Disable Keyboard 2 Calls
			//Calculation:
			//  KeyBd2TO = 1
			FCV_KEYBD2TO = 1;
			

		} else {
			//Disable Keyboard 1 Calls
			//Calculation:
			//  KeyBd1TO = 1
			FCV_KEYBD1TO = 1;
			

		}


	}


}

char FCM_ConfigRead(char FCL_INDEX, char FCL_DISPLAYEN)
{
	//Configuration EEPROM Read, Display, Check for and correct Out-of-Range Errors.
	//ID 0 = Option-on-Boot, ID 1 = Attract Mode, ID 2 = Pokey Float, ID 3 = KeyMap, ID 4 = Diag Arrows, ect.
	//DisplayEN 0 = No Display, 1 = Display Config State
	
	//Local variable definitions
	char FCL_TEMP;
	char FCL_ADDR;

	char FCR_RETVAL;

	//Out of bounds ?
	//Decision: ConfigRead.Index>7?
	if (FCL_INDEX>7)
	{
	} else {
		//Comment:
		//Retrieve Data


		//Calculate EEPROM Address
		//Calculation:
		//  ConfigRead.Addr = ((ConfigRead.Index+1)*32)-2
		FCL_ADDR = ((FCL_INDEX+1)*32)-2;
		

		//Get Setting from EEPROM
		//Call Component Macro: ConfigRead.Return=EEPROM(0)::Read(ConfigRead.Addr)
		FCR_RETVAL = FCD_EEPROM0_EEPROMRead(FCL_ADDR);


		//Comment:
		//Check Data


		//Out of range ?
		//Decision: ConfigRead.Return>1?
		if (FCR_RETVAL>1)
		{
			//KeyMap ?
			//Decision: ConfigRead.Index=3?
			if (FCL_INDEX==3)
			{
				//Out of range ?
				//Decision: ConfigRead.Return>3?
				if (FCR_RETVAL>3)
				{
					//Reset Value
					//Calculation:
					//  ConfigRead.Return = 0
					FCR_RETVAL = 0;
					

				}


			} else {
				//Reset Value
				//Calculation:
				//  ConfigRead.Return = 0
				FCR_RETVAL = 0;
				

			}


			//Update EEPROM to Match
			//Call Component Macro: EEPROM(0)::Write(ConfigRead.Addr, ConfigRead.Return)
			FCD_EEPROM0_WriteEEPROM(FCL_ADDR, FCR_RETVAL);


		}


	}


	//Comment:
	//Mode Display


	//Write to Screen ?
	//Decision: ConfigRead.DisplayEN?
	if (FCL_DISPLAYEN)
	{
		//Switch
		//Switch: ConfigRead.Index?
		switch (FCL_INDEX)
		{
			case 1:
			{
				//Comment:
				//Shows state of
				//Atari's annoying
				//color changing
				//Screen Saver.


				//Display SCREEN SAVE
				//Call Macro: StringSend("`SCREEN SAVE>= ")
				FCM_StringSend("`SCREEN SAVE>= ");


				//Attract Mode Disabled ?
				//Decision: ConfigRead.Return?
				if (FCR_RETVAL)
				{
					//Display Config State
					//Call Macro: StringSend("OFF~")
					FCM_StringSend("OFF~");


				} else {
					//Display Config State
					//Call Macro: StringSend("ON~")
					FCM_StringSend("ON~");


				}


				break;
			}

			case 2:
			{
				//Comment:
				//Displays state of
				//POKEY's key response
				//lines, with TTL being
				//used for XEGS.


				//Display XEGS MODE
				//Call Macro: StringSend("`XEGS/XEL>= ")
				FCM_StringSend("`XEGS/XEL>= ");


				//POKEY set to Float ?
				//Decision: ConfigRead.Return?
				if (FCR_RETVAL)
				{
					//Display Config State
					//Call Macro: StringSend("OFF~")
					FCM_StringSend("OFF~");


				} else {
					//Display Config State
					//Call Macro: StringSend("ON~")
					FCM_StringSend("ON~");


				}


				break;
			}

			case 3:
			{
				//Comment:
				//Shows state of
				//KeyMap selection


				//Display KEYMAP
				//Call Macro: StringSend("`KEYMAP>= ")
				FCM_StringSend("`KEYMAP>= ");


				//Switch
				//Switch: ConfigRead.Return?
				switch (FCR_RETVAL)
				{
					case 1:
					{
						//DE
						//Call Macro: StringSend("DE~")
						FCM_StringSend("DE~");


						break;
					}

					case 2:
					{
						//UK
						//Call Macro: StringSend("UK~")
						FCM_StringSend("UK~");


						break;
					}

					case 3:
					{
						//A8_ISO
						//Call Macro: StringSend("A8~")
						FCM_StringSend("A8~");


						break;
					}

					default:
					{
						//US
						//Call Macro: StringSend("US~")
						FCM_StringSend("US~");


					}
				}


				break;
			}

			case 4:
			{
				//Comment:
				//Shows whether the
				//diagonal arrow suppport
				//on the NumPad is ON
				//or OFF.


				//Display DIAG ARROWS
				//Call Macro: StringSend("`DIAG ARROWS>= ")
				FCM_StringSend("`DIAG ARROWS>= ");


				//Diag Arrows Enabled ?
				//Decision: ConfigRead.Return?
				if (FCR_RETVAL)
				{
					//Display Config State
					//Call Macro: StringSend("ON~")
					FCM_StringSend("ON~");


				} else {
					//Display Config State
					//Call Macro: StringSend("OFF~")
					FCM_StringSend("OFF~");


				}


				break;
			}

			case 5:
			{
				//Comment:
				//Shows if the XEGS's
				//built-in game has
				//been switched ON or
				//OFF for power-up. 


				//Display GAME
				//Call Macro: StringSend("`GAME BOOT>= ")
				FCM_StringSend("`GAME BOOT>= ");


				//SELECT on BOOT Enabled ?
				//Decision: ConfigRead.Return?
				if (FCR_RETVAL)
				{
					//Display Config State
					//Call Macro: StringSend("ON~")
					FCM_StringSend("ON~");


				} else {
					//Display Config State
					//Call Macro: StringSend("OFF~")
					FCM_StringSend("OFF~");


				}


				break;
			}

			case 6:
			{
				//Comment:
				//Shows whether the Caps
				//Mode is Standard Atari
				//or Special TK-II Mode.


				//Display CAPS MODE
				//Call Macro: StringSend("`CAPS MODE>= ")
				FCM_StringSend("`CAPS MODE>= ");


				//TK-II Caps Mode ?
				//Decision: ConfigRead.Return?
				if (FCR_RETVAL)
				{
					//Display Config State
					//Call Macro: StringSend("TK~")
					FCM_StringSend("TK~");


				} else {
					//Display Config State
					//Call Macro: StringSend("A8~")
					FCM_StringSend("A8~");


				}


				break;
			}

			case 7:
			{
				//Comment:
				//Shows whether the
				//Arrow keys are set
				//to cursor moves or
				//symbol output.


				//Display ARROW MODE
				//Call Macro: StringSend("`ARROW MODE>= ")
				FCM_StringSend("`ARROW MODE>= ");


				//Atari Arrows ?
				//Decision: ArrowTog?
				if (FCV_ARROWTOG)
				{
					//Display Config State
					//Call Macro: StringSend("A8~")
					FCM_StringSend("A8~");


				} else {
					//Display Config State
					//Call Macro: StringSend("TK~")
					FCM_StringSend("TK~");


				}


				break;
			}

			case 8:
			{
				//Comment:
				//Shows if cursor moves
				//are set for normal 'SLOW'
				//speed or double-step.


				//Display ARROW SPEED
				//Call Macro: StringSend("`ARROW SPEED>= ")
				FCM_StringSend("`ARROW SPEED>= ");


				//Hi-Speed Arrows ?
				//Decision: ArrowSpeed?
				if (FCV_ARROWSPEED)
				{
					//Display Config State
					//Call Macro: StringSend("FAST~")
					FCM_StringSend("FAST~");


				} else {
					//Display Config State
					//Call Macro: StringSend("SLOW~")
					FCM_StringSend("SLOW~");


				}


				break;
			}

			default:
			{
				//Comment:
				//Shows if internal
				//BASIC on XL
				//and XE computers
				//has been disabled.


				//Display OPTION
				//Call Macro: StringSend("`OPTION BOOT>= ")
				FCM_StringSend("`OPTION BOOT>= ");


				//OPTION on BOOT Enabled ?
				//Decision: ConfigRead.Return?
				if (FCR_RETVAL)
				{
					//Display Config State
					//Call Macro: StringSend("ON~")
					FCM_StringSend("ON~");


				} else {
					//Display Config State
					//Call Macro: StringSend("OFF~")
					FCM_StringSend("OFF~");


				}


			}
		}


	}


	//Clear Watch Dog Timer
	//C Code:
	clear_wdt();


	return (FCR_RETVAL);
}

void FCM_KeyDownCHK()
{
	//This routine is called whenever a console or reset key is pressed (F5-F8) in KeyProc, and then used to allow other POKEY related keys to be sent in parallel.
	
	//POKEY sending key ?
	//Decision: POKEen?
	if (FCV_POKEEN)
	{
		//Comment:
		//Replace newly entered
		//SCANcode with previous
		//one for key that is 
		//currently still pressed.


		//
		//Calculation:
		//  SCANcode = SCANold
		FCV_SCANCODE = FCV_SCANOLD;
		

	} else {
		//Clear Key
		//Calculation:
		//  SCANcode = 0
		FCV_SCANCODE = 0;
		

	}


	//Shift key down ?
	//Decision: SHIFT?
	if (FCV_SHIFT)
	{
		//Set Shift Key Down
		//Calculation:
		//  shf_key = 0x2F
		//  POKEen = 1
		FCV_SHF_KEY = 0x2F;
		FCV_POKEEN = 1;
		

	}


	//Control key down ?
	//Decision: CTRL?
	if (FCV_CTRL)
	{
		//Set Control Key Down
		//Calculation:
		//  ctl_key = 0x3F
		//  POKEen = 1
		FCV_CTL_KEY = 0x3F;
		FCV_POKEEN = 1;
		

	}


}

void FCM_CSfix()
{
	//Correct some of the keys when modified by CTRL or SHIFT. This is essentially a FIX that comes into play after initial key processing has already been done.
	
	//Shifted ?
	//Decision: SHIFT?
	if (FCV_SHIFT)
	{
		//Controlled ?
		//Decision: CTRL?
		if (FCV_CTRL)
		{
			//Comment:
			//Shifted and
			//Controlled Key


			//TILDE ?
			//Decision: SCANcode =0x0E?
			if (FCV_SCANCODE ==0x0E)
			{
				//
				//Calculation:
				//  POKEcode = 0xD8
				FCV_POKECODE = 0xD8;
				

			}


			//Number 2 ?
			//Decision: SCANcode =0x1E?
			if (FCV_SCANCODE ==0x1E)
			{
				//
				//Calculation:
				//  POKEcode = 0xE1
				FCV_POKECODE = 0xE1;
				

			}


			//Number 6 ?
			//Decision: SCANcode =0x36?
			if (FCV_SCANCODE ==0x36)
			{
				//
				//Calculation:
				//  POKEcode = 0xE4
				FCV_POKECODE = 0xE4;
				

			}


			//Number 7 ?
			//Decision: SCANcode =0x3D?
			if (FCV_SCANCODE ==0x3D)
			{
				//
				//Calculation:
				//  POKEcode = 0xCC
				FCV_POKECODE = 0xCC;
				

			}


			//Number 8 ?
			//Decision: SCANcode =0x3E?
			if (FCV_SCANCODE ==0x3E)
			{
				//
				//Calculation:
				//  POKEcode = 0xCA
				FCV_POKECODE = 0xCA;
				

			}


			//- ?
			//Decision: SCANcode=0x4E?
			if (FCV_SCANCODE==0x4E)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//= ?
			//Decision: SCANcode =0x55?
			if (FCV_SCANCODE ==0x55)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//[ ?
			//Decision: SCANcode =0x54?
			if (FCV_SCANCODE ==0x54)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//] ?
			//Decision: SCANcode =0x5B?
			if (FCV_SCANCODE ==0x5B)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//\ ?
			//Decision: SCANcode =0x5D?
			if (FCV_SCANCODE ==0x5D)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//' ?
			//Decision: SCANcode=0x52?
			if (FCV_SCANCODE==0x52)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//; ?
			//Decision: SCANcode =0x41?
			if (FCV_SCANCODE ==0x41)
			{
				//
				//Calculation:
				//  POKEcode = 0xDF
				FCV_POKECODE = 0xDF;
				

			}


			//. ?
			//Decision: SCANcode =0x49?
			if (FCV_SCANCODE ==0x49)
			{
				//
				//Calculation:
				//  POKEcode = 0xDD
				FCV_POKECODE = 0xDD;
				

			}


			//HOME ?
			//Decision: SCANcode =0x6C AND ext_key=1?
			if (FCV_SCANCODE ==0x6C & FCV_EXT_KEY==1)
			{
				//
				//Calculation:
				//  POKEcode = 0xC9
				FCV_POKECODE = 0xC9;
				

			}


		} else {
			//Comment:
			//Shifted Key
			//without Control


			//SPACE ?
			//Decision: SCANcode =0x29?
			if (FCV_SCANCODE ==0x29)
			{
				//
				//Calculation:
				//  POKEcode = 0x9E
				FCV_POKECODE = 0x9E;
				

			}


			//TILDE ?
			//Decision: SCANcode =0x0E?
			if (FCV_SCANCODE ==0x0E)
			{
				//
				//Calculation:
				//  POKEcode = 0x98
				FCV_POKECODE = 0x98;
				

			}


		}


	} else {
		//Controlled ?
		//Decision: CTRL?
		if (FCV_CTRL)
		{
			//Comment:
			//Controlled Key
			//without Shift


			//\ ?
			//Decision: SCANcode =0x5D?
			if (FCV_SCANCODE ==0x5D)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//HOME ?
			//Decision: SCANcode =0x6C AND ext_key=1?
			if (FCV_SCANCODE ==0x6C & FCV_EXT_KEY==1)
			{
				//
				//Calculation:
				//  POKEcode = 0x49
				FCV_POKECODE = 0x49;
				

			}


			//[ ?
			//Decision: SCANcode =0x54?
			if (FCV_SCANCODE ==0x54)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//] ?
			//Decision: SCANcode =0x5B?
			if (FCV_SCANCODE ==0x5B)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//- ?
			//Decision: SCANcode=0x4E?
			if (FCV_SCANCODE==0x4E)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//= ?
			//Decision: SCANcode=0x55?
			if (FCV_SCANCODE==0x55)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//' ?
			//Decision: SCANcode=0x52?
			if (FCV_SCANCODE==0x52)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


		} else {
			//Comment:
			//Normal Key
			//without Control
			//or Shift


		}


	}


}

void FCM_KeyMapDE()
{
	//Translate relocated symbols from German keyboard into US keyboard mapping. Also map in International character set where applicable.
	
	//Extended Key ?
	//Decision: ext_key?
	if (FCV_EXT_KEY)
	{
	} else {
		//Shifted ?
		//Decision: SHIFT?
		if (FCV_SHIFT)
		{
			//Controlled ?
			//Decision: CTRL?
			if (FCV_CTRL)
			{
				//Comment:
				//Shifted and
				//Controlled Key


				//
				//Decision: SCANcode=0x0E?
				if (FCV_SCANCODE==0x0E)
				{
					//
					//Calculation:
					//  POKEcode = 0x36
					FCV_POKECODE = 0x36;
					

				}


				//
				//Decision: SCANcode=0x1A?
				if (FCV_SCANCODE==0x1A)
				{
					//
					//Calculation:
					//  POKEcode = 0xD4
					FCV_POKECODE = 0xD4;
					

				}


				//
				//Decision: SCANcode=0x35?
				if (FCV_SCANCODE==0x35)
				{
					//
					//Calculation:
					//  POKEcode = 0xE8
					FCV_POKECODE = 0xE8;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0xD8
					FCV_POKECODE = 0xD8;
					

				}


				//
				//Decision: SCANcode=0x61?
				if (FCV_SCANCODE==0x61)
				{
					//
					//Calculation:
					//  POKEcode = 0x36
					FCV_POKECODE = 0x36;
					

				}


			} else {
				//Comment:
				//Shifted Key
				//without Control


				//
				//Decision: SCANcode=0x0E?
				if (FCV_SCANCODE==0x0E)
				{
					//
					//Calculation:
					//  POKEcode = 0x36
					FCV_POKECODE = 0x36;
					

				}


				//
				//Decision: SCANcode=0x1A?
				if (FCV_SCANCODE==0x1A)
				{
					//
					//Calculation:
					//  POKEcode = 0x94
					FCV_POKECODE = 0x94;
					

				}


				//
				//Decision: SCANcode=0x1E?
				if (FCV_SCANCODE==0x1E)
				{
					//
					//Calculation:
					//  POKEcode = 0xA1
					FCV_POKECODE = 0xA1;
					

				}


				//
				//Decision: SCANcode=0x26?
				if (FCV_SCANCODE==0x26)
				{
					//
					//Calculation:
					//  POKEcode = 0x36
					FCV_POKECODE = 0x36;
					

				}


				//
				//Decision: SCANcode=0x35?
				if (FCV_SCANCODE==0x35)
				{
					//
					//Calculation:
					//  POKEcode = 0xA8
					FCV_POKECODE = 0xA8;
					

				}


				//
				//Decision: SCANcode=0x36?
				if (FCV_SCANCODE==0x36)
				{
					//
					//Calculation:
					//  POKEcode = 0xA4
					FCV_POKECODE = 0xA4;
					

				}


				//
				//Decision: SCANcode=0x3D?
				if (FCV_SCANCODE==0x3D)
				{
					//
					//Calculation:
					//  POKEcode = 0x19
					FCV_POKECODE = 0x19;
					

				}


				//
				//Decision: SCANcode=0x3E?
				if (FCV_SCANCODE==0x3E)
				{
					//
					//Calculation:
					//  POKEcode = 0x8F
					FCV_POKECODE = 0x8F;
					

				}


				//
				//Decision: SCANcode=0x41?
				if (FCV_SCANCODE==0x41)
				{
					//
					//Calculation:
					//  POKEcode = 0x3D
					FCV_POKECODE = 0x3D;
					

				}


				//
				//Decision: SCANcode=0x46?
				if (FCV_SCANCODE==0x46)
				{
					//
					//Calculation:
					//  POKEcode = 0x8D
					FCV_POKECODE = 0x8D;
					

				}


				//
				//Decision: SCANcode=0x45?
				if (FCV_SCANCODE==0x45)
				{
					//
					//Calculation:
					//  POKEcode = 0x30
					FCV_POKECODE = 0x30;
					

				}


				//
				//Decision: SCANcode=0x49?
				if (FCV_SCANCODE==0x49)
				{
					//
					//Calculation:
					//  POKEcode = 0xBD
					FCV_POKECODE = 0xBD;
					

				}


				//
				//Decision: SCANcode=0x4A?
				if (FCV_SCANCODE==0x4A)
				{
					//
					//Calculation:
					//  POKEcode = 0xB1
					FCV_POKECODE = 0xB1;
					

				}


				//
				//Decision: SCANcode=0x4C?
				if (FCV_SCANCODE==0x4C)
				{
					//
					//Calculation:
					//  POKEcode = 0x7F
					FCV_POKECODE = 0x7F;
					

				}


				//
				//Decision: SCANcode=0x4E?
				if (FCV_SCANCODE==0x4E)
				{
					//
					//Calculation:
					//  POKEcode = 0x99
					FCV_POKECODE = 0x99;
					

				}


				//
				//Decision: SCANcode=0x52?
				if (FCV_SCANCODE==0x52)
				{
					//
					//Calculation:
					//  POKEcode = 0x7D
					FCV_POKECODE = 0x7D;
					

				}


				//
				//Decision: SCANcode=0x54?
				if (FCV_SCANCODE==0x54)
				{
					//
					//Calculation:
					//  POKEcode = 0x75
					FCV_POKECODE = 0x75;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0x98
					FCV_POKECODE = 0x98;
					

				}


				//
				//Decision: SCANcode=0x5B?
				if (FCV_SCANCODE==0x5B)
				{
					//
					//Calculation:
					//  POKEcode = 0x38
					FCV_POKECODE = 0x38;
					

				}


				//
				//Decision: SCANcode=0x5D?
				if (FCV_SCANCODE==0x5D)
				{
					//
					//Calculation:
					//  POKEcode = 0x8C
					FCV_POKECODE = 0x8C;
					

				}


				//
				//Decision: SCANcode=0x61?
				if (FCV_SCANCODE==0x61)
				{
					//
					//Calculation:
					//  POKEcode = 0x08
					FCV_POKECODE = 0x08;
					

				}


				//Caps Lock ?
				//Decision: CAPS?
				if (FCV_CAPS)
				{
					//Comment:
					//Caps Lock and
					//Shifted without
					//Control


					//
					//Decision: SCANcode=0x1A?
					if (FCV_SCANCODE==0x1A)
					{
						//
						//Calculation:
						//  POKEcode = 0x14
						FCV_POKECODE = 0x14;
						

					}


					//
					//Decision: SCANcode=0x35?
					if (FCV_SCANCODE==0x35)
					{
						//
						//Calculation:
						//  POKEcode = 0x28
						FCV_POKECODE = 0x28;
						

					}


					//
					//Decision: SCANcode=0x4C?
					if (FCV_SCANCODE==0x4C)
					{
						//
						//Calculation:
						//  POKEcode = 0x77
						FCV_POKECODE = 0x77;
						

					}


					//
					//Decision: SCANcode=0x52?
					if (FCV_SCANCODE==0x52)
					{
						//
						//Calculation:
						//  POKEcode = 0x7A
						FCV_POKECODE = 0x7A;
						

					}


					//
					//Decision: SCANcode=0x54?
					if (FCV_SCANCODE==0x54)
					{
						//
						//Calculation:
						//  POKEcode = 0x7E
						FCV_POKECODE = 0x7E;
						

					}


				}


			}


		} else {
			//Controlled ?
			//Decision: CTRL?
			if (FCV_CTRL)
			{
				//Comment:
				//Controlled Key
				//without Shift


				//
				//Decision: SCANcode=0x0E?
				if (FCV_SCANCODE==0x0E)
				{
					//
					//Calculation:
					//  POKEcode = 0x36
					FCV_POKECODE = 0x36;
					

				}


				//
				//Decision: SCANcode=0x1A?
				if (FCV_SCANCODE==0x1A)
				{
					//
					//Calculation:
					//  POKEcode = 0x54
					FCV_POKECODE = 0x54;
					

				}


				//
				//Decision: SCANcode=0x35?
				if (FCV_SCANCODE==0x35)
				{
					//
					//Calculation:
					//  POKEcode = 0x68
					FCV_POKECODE = 0x68;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0x58
					FCV_POKECODE = 0x58;
					

				}


				//
				//Decision: SCANcode=0x61?
				if (FCV_SCANCODE==0x61)
				{
					//
					//Calculation:
					//  POKEcode = 0x36
					FCV_POKECODE = 0x36;
					

				}


			} else {
				//Comment:
				//Normal Key
				//without Control
				//or Shift


				//
				//Decision: SCANcode=0x0E?
				if (FCV_SCANCODE==0x0E)
				{
					//
					//Calculation:
					//  POKEcode = 0xB8
					FCV_POKECODE = 0xB8;
					

				}


				//
				//Decision: SCANcode=0x1A?
				if (FCV_SCANCODE==0x1A)
				{
					//
					//Calculation:
					//  POKEcode = 0x14
					FCV_POKECODE = 0x14;
					

				}


				//
				//Decision: SCANcode=0x35?
				if (FCV_SCANCODE==0x35)
				{
					//
					//Calculation:
					//  POKEcode = 0x28
					FCV_POKECODE = 0x28;
					

				}


				//
				//Decision: SCANcode=0x4A?
				if (FCV_SCANCODE==0x4A)
				{
					//
					//Calculation:
					//  POKEcode = 0x31
					FCV_POKECODE = 0x31;
					

				}


				//
				//Decision: SCANcode=0x4C?
				if (FCV_SCANCODE==0x4C)
				{
					//
					//Calculation:
					//  POKEcode = 0x77
					FCV_POKECODE = 0x77;
					

				}


				//
				//Decision: SCANcode=0x4E?
				if (FCV_SCANCODE==0x4E)
				{
					//Alt Gr ?
					//Decision: ALTgr=1?
					if (FCV_ALTGR==1)
					{
						//
						//Calculation:
						//  POKEcode = 0xB9
						FCV_POKECODE = 0xB9;
						

					} else {
						//Send double 'ss'
						//Call Macro: StringSend("ss")
						FCM_StringSend("ss");


						//
						//Calculation:
						//  POKEcode = 0x36
						FCV_POKECODE = 0x36;
						

					}


				}


				//
				//Decision: SCANcode=0x52?
				if (FCV_SCANCODE==0x52)
				{
					//
					//Calculation:
					//  POKEcode = 0x7A
					FCV_POKECODE = 0x7A;
					

				}


				//
				//Decision: SCANcode=0x54?
				if (FCV_SCANCODE==0x54)
				{
					//
					//Calculation:
					//  POKEcode = 0x7E
					FCV_POKECODE = 0x7E;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0x18
					FCV_POKECODE = 0x18;
					

				}


				//
				//Decision: SCANcode=0x5B?
				if (FCV_SCANCODE==0x5B)
				{
					//
					//Calculation:
					//  POKEcode = 0x39
					FCV_POKECODE = 0x39;
					

				}


				//
				//Decision: SCANcode=0x5D?
				if (FCV_SCANCODE==0x5D)
				{
					//
					//Calculation:
					//  POKEcode = 0xA5
					FCV_POKECODE = 0xA5;
					

				}


				//
				//Decision: SCANcode=0x61?
				if (FCV_SCANCODE==0x61)
				{
					//
					//Calculation:
					//  POKEcode = 0x09
					FCV_POKECODE = 0x09;
					

				}


				//Caps Lock ?
				//Decision: CAPS?
				if (FCV_CAPS)
				{
					//Comment:
					//Caps Lock without
					//Shift or Control


					//
					//Decision: SCANcode=0x1A?
					if (FCV_SCANCODE==0x1A)
					{
						//
						//Calculation:
						//  POKEcode = 0x94
						FCV_POKECODE = 0x94;
						

					}


					//
					//Decision: SCANcode=0x35?
					if (FCV_SCANCODE==0x35)
					{
						//
						//Calculation:
						//  POKEcode = 0xA8
						FCV_POKECODE = 0xA8;
						

					}


					//
					//Decision: SCANcode=0x4C?
					if (FCV_SCANCODE==0x4C)
					{
						//
						//Calculation:
						//  POKEcode = 0x7F
						FCV_POKECODE = 0x7F;
						

					}


					//
					//Decision: SCANcode=0x52?
					if (FCV_SCANCODE==0x52)
					{
						//
						//Calculation:
						//  POKEcode = 0x7D
						FCV_POKECODE = 0x7D;
						

					}


					//
					//Decision: SCANcode=0x54?
					if (FCV_SCANCODE==0x54)
					{
						//
						//Calculation:
						//  POKEcode = 0x75
						FCV_POKECODE = 0x75;
						

					}


				}


			}


		}


	}


}

void FCM_INITps2()
{
	//This routine performs a full initilization of the both PS2 Keyboards.
	
	//Reset Keyboard #1
	//Call Macro: PS2write(0xFF, 0)
	FCM_PS2write(0xFF, 0);


	//Delay
	//Delay: 100 ms
	delay_ms(100);


	//Reset Keyboard #2
	//Call Macro: PS2write(0xFF, 1)
	FCM_PS2write(0xFF, 1);


	//Delay
	//Delay: 100 ms
	delay_ms(100);


	//Reset Timeouts
	//Calculation:
	//  KeyBd1TO = 0
	//  KeyBd2TO = 0
	FCV_KEYBD1TO = 0;
	FCV_KEYBD2TO = 0;
	

	//Update LEDs
	//Call Macro: LEDupdate
	FCM_LEDupdate();


	//Delay
	//Delay: 300 ms
	delay_ms(255);
	delay_ms(45);


	//Reset Timeouts
	//Calculation:
	//  KeyBd1TO = 0
	//  KeyBd2TO = 0
	FCV_KEYBD1TO = 0;
	FCV_KEYBD2TO = 0;
	

	//Update LEDs
	//Call Macro: LEDupdate
	FCM_LEDupdate();


}

void FCM_WIggle(char FCL_X)
{
	//Sends CTRL+Arrow keys to create either a back and forth wiggle. The wiggle parameter determines how many times to do this.
	
	//Adjust Count
	//Calculation:
	//  WIggle.X = WIggle.X+1
	FCL_X = FCL_X+1;
	

	//Loop
	//Loop: While WIggle.X
	while (FCL_X)
	{
		//Single Wiggle Cursor
		//Call Macro: StringSend("}{")
		FCM_StringSend("}{");


		//Delay
		//Delay: 150 ms
		delay_ms(150);


		//
		//Decision: WIggle.X?
		if (FCL_X)
		{
			//Decrement Count
			//Calculation:
			//  WIggle.X = WIggle.X-1
			FCL_X = FCL_X-1;
			

		}


	}


}

void FCM_PS2time()
{
	//This is a general purpose 1 milli-second timer that is used by the PS2 bit sending macros PS2clkPos and PS2sendBit to dtermine timeouts.
	
	//Delay
	//Delay: 1 us
	delay_us(1);


	//Increment 1st Counter
	//Calculation:
	//  TOcnt0 = TOcnt0+1
	FCV_TOCNT0 = FCV_TOCNT0+1;
	

	//1 ms Elasped ?
	//Decision: TOcnt0=1000?
	if (FCV_TOCNT0==1000)
	{
		//Increment 2nd counter
		//Calculation:
		//  TOcnt1 = TOcnt1+1
		//  TOcnt0 = 0
		FCV_TOCNT1 = FCV_TOCNT1+1;
		FCV_TOCNT0 = 0;
		

	}


}

void FCM_KeyMapUK()
{
	//Translate relocated symbols from UK keyboard into US keyboard mapping.
	
	//Shifted ?
	//Decision: SHIFT?
	if (FCV_SHIFT)
	{
		//Controlled ?
		//Decision: CTRL?
		if (FCV_CTRL)
		{
			//Comment:
			//Shifted and
			//Controlled Key


			//
			//Decision: SCANcode=0x61?
			if (FCV_SCANCODE==0x61)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


		} else {
			//Comment:
			//Shifted Key
			//without Control


			//
			//Decision: SCANcode=0x61?
			if (FCV_SCANCODE==0x61)
			{
				//
				//Calculation:
				//  POKEcode = 0xB0
				FCV_POKECODE = 0xB0;
				

			}


			//
			//Decision: SCANcode=0x5D?
			if (FCV_SCANCODE==0x5D)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//
			//Decision: SCANcode=0x1E?
			if (FCV_SCANCODE==0x1E)
			{
				//
				//Calculation:
				//  POKEcode = 0xA1
				FCV_POKECODE = 0xA1;
				

			}


			//
			//Decision: SCANcode=0x26?
			if (FCV_SCANCODE==0x26)
			{
				//
				//Calculation:
				//  POKEcode = 0x36
				FCV_POKECODE = 0x36;
				

			}


			//
			//Decision: SCANcode=0x52?
			if (FCV_SCANCODE==0x52)
			{
				//
				//Calculation:
				//  POKEcode = 0x8A
				FCV_POKECODE = 0x8A;
				

			}


		}


	} else {
		//Controlled ?
		//Decision: CTRL?
		if (FCV_CTRL)
		{
			//Comment:
			//Controlled Key
			//without Shift


		} else {
			//Comment:
			//Normal Key
			//without Control
			//or Shift


			//
			//Decision: SCANcode=0x61?
			if (FCV_SCANCODE==0x61)
			{
				//
				//Calculation:
				//  POKEcode = 0xB9
				FCV_POKECODE = 0xB9;
				

			}


			//
			//Decision: SCANcode=0x5D?
			if (FCV_SCANCODE==0x5D)
			{
				//
				//Calculation:
				//  POKEcode = 0xA5
				FCV_POKECODE = 0xA5;
				

			}


		}


	}


}

void FCM_KeyMapA8()
{
	
	//Extended Key ?
	//Decision: ext_key?
	if (FCV_EXT_KEY)
	{
	} else {
		//Shifted ?
		//Decision: SHIFT?
		if (FCV_SHIFT)
		{
			//Controlled ?
			//Decision: CTRL?
			if (FCV_CTRL)
			{
				//Comment:
				//Shifted and
				//Controlled Key


			} else {
				//Comment:
				//Shifted Key
				//without Control


				//
				//Decision: SCANcode=0x1E?
				if (FCV_SCANCODE==0x1E)
				{
					//
					//Calculation:
					//  POKEcode = 0xA1
					FCV_POKECODE = 0xA1;
					

				}


				//
				//Decision: SCANcode=0x36?
				if (FCV_SCANCODE==0x36)
				{
					//
					//Calculation:
					//  POKEcode = 0xA4
					FCV_POKECODE = 0xA4;
					

				}


				//
				//Decision: SCANcode=0x3D?
				if (FCV_SCANCODE==0x3D)
				{
					//
					//Calculation:
					//  POKEcode = 0x8C
					FCV_POKECODE = 0x8C;
					

				}


				//
				//Decision: SCANcode=0x3E?
				if (FCV_SCANCODE==0x3E)
				{
					//
					//Calculation:
					//  POKEcode = 0x8A
					FCV_POKECODE = 0x8A;
					

				}


				//
				//Decision: SCANcode=0x41?
				if (FCV_SCANCODE==0x41)
				{
					//
					//Calculation:
					//  POKEcode = 0x9F
					FCV_POKECODE = 0x9F;
					

				}


				//
				//Decision: SCANcode=0x49?
				if (FCV_SCANCODE==0x49)
				{
					//
					//Calculation:
					//  POKEcode = 0x9D
					FCV_POKECODE = 0x9D;
					

				}


				//
				//Decision: SCANcode=0x4E?
				if (FCV_SCANCODE==0x4E)
				{
					//
					//Calculation:
					//  POKEcode = 0x89
					FCV_POKECODE = 0x89;
					

				}


				//
				//Decision: SCANcode=0x52?
				if (FCV_SCANCODE==0x52)
				{
					//
					//Calculation:
					//  POKEcode = 0xB9
					FCV_POKECODE = 0xB9;
					

				}


				//
				//Decision: SCANcode=0x54?
				if (FCV_SCANCODE==0x54)
				{
					//
					//Calculation:
					//  POKEcode = 0xB1
					FCV_POKECODE = 0xB1;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0x88
					FCV_POKECODE = 0x88;
					

				}


				//
				//Decision: SCANcode=0x5B?
				if (FCV_SCANCODE==0x5B)
				{
					//
					//Calculation:
					//  POKEcode = 0xB0
					FCV_POKECODE = 0xB0;
					

				}


				//
				//Decision: SCANcode=0x5D?
				if (FCV_SCANCODE==0x5D)
				{
					//
					//Calculation:
					//  POKEcode = 0xB8
					FCV_POKECODE = 0xB8;
					

				}


			}


		} else {
			//Controlled ?
			//Decision: CTRL?
			if (FCV_CTRL)
			{
				//Comment:
				//Controlled Key
				//without Shift


				//
				//Decision: SCANcode=0x1E?
				if (FCV_SCANCODE==0x1E)
				{
					//
					//Calculation:
					//  POKEcode = 0x61
					FCV_POKECODE = 0x61;
					

				}


				//
				//Decision: SCANcode=0x36?
				if (FCV_SCANCODE==0x36)
				{
					//
					//Calculation:
					//  POKEcode = 0x64
					FCV_POKECODE = 0x64;
					

				}


				//
				//Decision: SCANcode=0x3D?
				if (FCV_SCANCODE==0x3D)
				{
					//
					//Calculation:
					//  POKEcode = 0x4C
					FCV_POKECODE = 0x4C;
					

				}


				//
				//Decision: SCANcode=0x3E?
				if (FCV_SCANCODE==0x3E)
				{
					//
					//Calculation:
					//  POKEcode = 0x4A
					FCV_POKECODE = 0x4A;
					

				}


				//
				//Decision: SCANcode=0x41?
				if (FCV_SCANCODE==0x41)
				{
					//
					//Calculation:
					//  POKEcode = 0x5F
					FCV_POKECODE = 0x5F;
					

				}


				//
				//Decision: SCANcode=0x49?
				if (FCV_SCANCODE==0x49)
				{
					//
					//Calculation:
					//  POKEcode = 0x5D
					FCV_POKECODE = 0x5D;
					

				}


				//
				//Decision: SCANcode=0x4E?
				if (FCV_SCANCODE==0x4E)
				{
					//
					//Calculation:
					//  POKEcode = 0x49
					FCV_POKECODE = 0x49;
					

				}


				//
				//Decision: SCANcode=0x52?
				if (FCV_SCANCODE==0x52)
				{
					//
					//Calculation:
					//  POKEcode = 0x79
					FCV_POKECODE = 0x79;
					

				}


				//
				//Decision: SCANcode=0x54?
				if (FCV_SCANCODE==0x54)
				{
					//
					//Calculation:
					//  POKEcode = 0x71
					FCV_POKECODE = 0x71;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0x48
					FCV_POKECODE = 0x48;
					

				}


				//
				//Decision: SCANcode=0x5B?
				if (FCV_SCANCODE==0x5B)
				{
					//
					//Calculation:
					//  POKEcode = 0x70
					FCV_POKECODE = 0x70;
					

				}


				//
				//Decision: SCANcode=0x5D?
				if (FCV_SCANCODE==0x5D)
				{
					//
					//Calculation:
					//  POKEcode = 0x78
					FCV_POKECODE = 0x78;
					

				}


			} else {
				//Comment:
				//Normal Key
				//without Control
				//or Shift


				//
				//Decision: SCANcode=0x4E?
				if (FCV_SCANCODE==0x4E)
				{
					//
					//Calculation:
					//  POKEcode = 0x09
					FCV_POKECODE = 0x09;
					

				}


				//
				//Decision: SCANcode=0x52?
				if (FCV_SCANCODE==0x52)
				{
					//
					//Calculation:
					//  POKEcode = 0x39
					FCV_POKECODE = 0x39;
					

				}


				//
				//Decision: SCANcode=0x54?
				if (FCV_SCANCODE==0x54)
				{
					//
					//Calculation:
					//  POKEcode = 0x31
					FCV_POKECODE = 0x31;
					

				}


				//
				//Decision: SCANcode=0x55?
				if (FCV_SCANCODE==0x55)
				{
					//
					//Calculation:
					//  POKEcode = 0x08
					FCV_POKECODE = 0x08;
					

				}


				//
				//Decision: SCANcode=0x5B?
				if (FCV_SCANCODE==0x5B)
				{
					//
					//Calculation:
					//  POKEcode = 0x30
					FCV_POKECODE = 0x30;
					

				}


				//
				//Decision: SCANcode=0x5D?
				if (FCV_SCANCODE==0x5D)
				{
					//
					//Calculation:
					//  POKEcode = 0x38
					FCV_POKECODE = 0x38;
					

				}


			}


		}


	}


	//Special 'TK' Key
	//Decision: SCANcode=0x61?
	if (FCV_SCANCODE==0x61)
	{
		//Assign it to Un-Used Key
		//Calculation:
		//  POKEcode = 0x16
		FCV_POKECODE = 0x16;
		

		//Add both CTRL + SHIFT
		//Calculation:
		//  temp = SHIFT <<7
		//  temp = temp OR CTRL <<6
		//  POKEcode = temp OR POKEcode
		FCV_TEMP = FCV_SHIFT <<7;
		FCV_TEMP = FCV_TEMP | FCV_CTRL <<6;
		FCV_POKECODE = FCV_TEMP | FCV_POKECODE;
		

	}


}

void FCM_KeySend2()
{
	
	//
	//Calculation:
	//  POKEen = 1
	//  Nonkey = 1
	FCV_POKEEN = 1;
	FCV_NONKEY = 1;
	

	//Call Macro
	//Call Macro: KeySend
	FCM_KeySend();


}

//Supplementary implementations


void main()
{
	//Version 1.9X Production Code for XEL --- June 2017
	//Added support for Sustained RESET on 1st Boot, also added Console Key exit from U1MB Menu via Cold Boot shortcut key.
	
	//Initialisation
	ansela = 0x00;
anselb = 0x00;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Retrieve Cause of Reset
	//C Code:
	FCV_TO = status.4;


	//Comment:
	//Initialize PIC16F1847
	//Parameters


	//C Code
	//C Code:
	clear_bit(option_reg , 7);	// Enable weak pull-ups
	wpub = 0xFF;				// PortB weak pull-ups ON
	osccon = 0xF0;				// 32 Mhz Internal Oscillator
	wdtcon = 0x1B;				// Watchdog = 8-10 seconds


	//init misc variables
	//Calculation:
	//  KeyTime = 12
	//  TOmsSet = 3
	//  TOcnt0 = 0
	//  TOcnt1 = 0
	//  ok = 0
	//  kdata = 0
	//  SCANcode = 0
	//  ext_key = 0
	//  rel_key = 0
	//  in = 0
	//  cnt = 0
	//  clk = 1
	//  CAPS = 1
	//  NUMlock = 1
	//  SHIFT = 0
	//  SHIFTold = 0
	//  CTRL = 0
	//  ALT = 0
	//  ALTgr = 0
	//  brk_key = 0
	//  shf_key = 0
	//  ctl_key = 0
	//  rst_key = 0
	//  brk_bytes = 0
	//  POKEen = 0
	//  POKEcode = 0
	//  ADDRptr = 0
	//  CLIPbuf[31] = 0
	//  record = 0
	//  INSmode = 0
	//  KBindxI = 0
	//  KBindxO = 0
	//  slow = 0
	//  KeyBd1TO = 0
	//  KeyBd2TO = 0
	//  ArrowTog = 0
	//  ArrowSpeed = 0
	//  JIFFY1 = 0
	//  JIFFY2 = 0
	//  Sustain = 0
	//  ADDRptr = ADDRtemp
	//  BAT = 0
	//  List = 0
	//  KEYscan = 0
	//  Umenu = 0
	//  UmenuTMP = 0
	//  resync = 0
	//  Console = 0
	FCV_KEYTIME = 12;
	FCV_TOMSSET = 3;
	FCV_TOCNT0 = 0;
	FCV_TOCNT1 = 0;
	FCV_OK = 0;
	FCV_KDATA = 0;
	FCV_SCANCODE = 0;
	FCV_EXT_KEY = 0;
	FCV_REL_KEY = 0;
	FCV_IN = 0;
	FCV_CNT = 0;
	FCV_CLK = 1;
	FCV_CAPS = 1;
	FCV_NUMLOCK = 1;
	FCV_SHIFT = 0;
	FCV_SHIFTOLD = 0;
	FCV_CTRL = 0;
	FCV_ALT = 0;
	FCV_ALTGR = 0;
	FCV_BRK_KEY = 0;
	FCV_SHF_KEY = 0;
	FCV_CTL_KEY = 0;
	FCV_RST_KEY = 0;
	FCV_BRK_BYTES = 0;
	FCV_POKEEN = 0;
	FCV_POKECODE = 0;
	FCV_ADDRPTR = 0;
	FCV_CLIPBUF[31] = 0;
	FCV_RECORD = 0;
	FCV_INSMODE = 0;
	FCV_KBINDXI = 0;
	FCV_KBINDXO = 0;
	FCV_SLOW = 0;
	FCV_KEYBD1TO = 0;
	FCV_KEYBD2TO = 0;
	FCV_ARROWTOG = 0;
	FCV_ARROWSPEED = 0;
	FCV_JIFFY1 = 0;
	FCV_JIFFY2 = 0;
	FCV_SUSTAIN = 0;
	FCV_ADDRPTR = FCV_ADDRTEMP;
	FCV_BAT = 0;
	FCV_LIST = 0;
	FCV_KEYSCAN = 0;
	FCV_UMENU = 0;
	FCV_UMENUTMP = 0;
	FCV_RESYNC = 0;
	FCV_CONSOLE = 0;
	

	//Check EEPROM Validity
	//Call Macro: EEPROMinit
	FCM_EEPROMinit();


	//Watch Dog Good ?
	//Decision: TO?
	if (FCV_TO)
	{
		//Comment:
		//Upon powering up for
		//the 1st time...
		//RESET is held LOW.


		//Set Reset LOW
		//Output: 0 -> B7
		trisb = trisb & 0x7f;
		if (0)
			portb = (portb & 0x7f) | 0x80;
		else
			portb = portb & 0x7f;


	}


	//Retrieve Attract Mode
	//Call Macro: NoAttract=ConfigRead(1, 0)
	FCV_NOATTRACT = FCM_ConfigRead(1, 0);


	//Retrieve XEGS Mode
	//Call Macro: float=ConfigRead(2, 0)
	FCV_FLOAT = FCM_ConfigRead(2, 0);


	//Float KR1 and KR2 ?
	//Decision: float?
	if (FCV_FLOAT)
	{
		//Comment:
		//Set KR1 and KR2 as
		//inputs and allow
		//pull-up resistors
		//to bring them High.


		//KR1 and KR2 Float HI
		//Input: PORTA -> KR
		trisa = trisa | 0xc0;
		FCV_KR = porta & 0xc0;


	} else {
		//Comment:
		//Set KR1 and KR2 as
		//ACTIVE High outputs,
		//where no pull-up
		//resistors exist.


		//KR1 and KR2 Output HI
		//Output: 0xC0 -> PORTA
		trisa = trisa & 0x3f;
		porta = (porta & 0x3f) | (0xC0 & 0xc0);


	}


	//Retrieve Keyboard Mapping
	//Call Macro: KeyMap=ConfigRead(3, 0)
	FCV_KEYMAP = FCM_ConfigRead(3, 0);


	//Retrieve Diag Arrows State
	//Call Macro: DiagArrows=ConfigRead(4, 0)
	FCV_DIAGARROWS = FCM_ConfigRead(4, 0);


	//Retrieve CAPS MODE State
	//Call Macro: TKcaps=ConfigRead(6, 0)
	FCV_TKCAPS = FCM_ConfigRead(6, 0);


	//Delay
	//Delay: 2 s
	delay_s(2);


	//TK-II CAPS Mode ?
	//Decision: TKcaps>0?
	if (FCV_TKCAPS>0)
	{
		//Enable Caps and Num LED's
		//Calculation:
		//  LED = 6
		FCV_LED = 6;
		

	} else {
		//Enable Num LED only
		//Calculation:
		//  LED = 2
		FCV_LED = 2;
		

	}


	//INIT Keyboard(s) and LEDs
	//Call Macro: INITps2
	FCM_INITps2();


	//Comment:
	//Check WatchDog for
	//time out, and if it
	//did, then warm keyboard
	//re-init occurred.


	//Comment:
	//Send a do nothing key
	//to clear the KeySend
	//routine for normal
	//transmission.


	//Clear KeySend
	//Calculation:
	//  POKEcode = 0xC0
	FCV_POKECODE = 0xC0;
	

	//Send It
	//Call Macro: KeySend2
	FCM_KeySend2();


	//Watch Dog Good ?
	//Decision: TO?
	if (FCV_TO)
	{
		//Release Reset
		//Input: B7 -> temp
		trisb = trisb | 0x80;
		FCV_TEMP = ((portb & 0x80) == 0x80);


		//Clear Watch Dog Timer
		//C Code:
		clear_wdt();


		//Retrieve OPTION-on-BOOT
		//Call Macro: OptionBootEN=ConfigRead(0, 0)
		FCV_OPTIONBOOTEN = FCM_ConfigRead(0, 0);


		//Comment:
		//If OPTION on BOOT has
		//been enabled, then hold
		//OPTION key during Boot-Up
		//process to disable BASIC.


		//OPTION on BOOT Enabled ?
		//Decision: OptionBootEN?
		if (FCV_OPTIONBOOTEN)
		{
			//Output (OPTION)
			//Output: 0 -> B6
			trisb = trisb & 0xbf;
			if (0)
				portb = (portb & 0xbf) | 0x40;
			else
				portb = portb & 0xbf;


			//Delay
			//Delay: 3 s
			delay_s(3);


		}


		//Retrieve SELECT-on-BOOT
		//Call Macro: SelectBootEN=ConfigRead(5, 0)
		FCV_SELECTBOOTEN = FCM_ConfigRead(5, 0);


		//Comment:
		//If SELECT on BOOT has
		//been enabled, then hold
		//SELECT key during Boot-Up
		//to enable XEGS GAME.


		//SELECT on BOOT Enabled ?
		//Decision: SelectBootEN?
		if (FCV_SELECTBOOTEN)
		{
			//Output (SELECT)
			//Output: 0 -> B5
			trisb = trisb & 0xdf;
			if (0)
				portb = (portb & 0xdf) | 0x20;
			else
				portb = portb & 0xdf;


			//Delay
			//Delay: 3 s
			delay_s(3);


		}


		//Comment:
		//Look for Held Key


		//Loop
		//Loop: Loop 10 times
		for (FCLV_LOOP1=0; FCLV_LOOP1<10; FCLV_LOOP1++)
		{
			//Process Keys
			//Call Macro: KeyProc
			FCM_KeyProc();


			//Delay
			//Delay: 50 ms
			delay_ms(50);


		}


		//Clear 
		//Calculation:
		//  SCANcode = 0
		FCV_SCANCODE = 0;
		

		//TK-II CAPS Mode ?
		//Decision: TKcaps?
		if (FCV_TKCAPS)
		{
			//Delay 60sec -- Send Caps
			//Call Macro: CapsSync(220)
			FCM_CapsSync(220);


		}


		//Release Console
		//Input: PORTB -> temp
		trisb = trisb | 0x70;
		FCV_TEMP = portb & 0x70;


	}


	//Comment:
	//====== BEGIN ======
	//     MAIN ROUTINE
	//==================


	//Main Loop
	//Loop: While 1
	while (1)
	{
		//Clear Watch Dog Timer
		//C Code:
		clear_wdt();


		//Keyboard came online ?
		//Decision: BAT?
		if (FCV_BAT)
		{
			//Comment:
			//=== Keyboard Detected ===
			//Possibly caused by
			//hot plugging keyboard.


			//Clear flag
			//Calculation:
			//  BAT = 0
			FCV_BAT = 0;
			

			//Update LEDs
			//Call Macro: LEDupdate
			FCM_LEDupdate();


		}


		//Comment:
		//If Warm Reset, toggle
		//Atari Caps key to sync.


		//Reset key pressed ?
		//Decision: rst_key AND TKcaps?
		if (FCV_RST_KEY & FCV_TKCAPS)
		{
			//Delay 60sec -- Send Caps
			//Call Macro: CapsSync(220)
			FCM_CapsSync(220);


		}


		//Got key ?
		//Decision: ok?
		if (FCV_OK)
		{
			//Comment:
			//Do Keyboard Related Stuff


			//Comment:
			//Clear NEW Key Flag and
			//begin final processing
			//of received key data.


			//
			//Calculation:
			//  ok = 0
			FCV_OK = 0;
			

			//Comment:
			//SCANCODE-TO-ASCII LUT
			//Translate keybd scancodes
			//into ASCII for all recognized
			//non-shifted characters.


			//C Code
			//C Code:
			/*  Translate raw scan code from abstract to ASCII
				using look-up table stored in...
				View-Project Options-supplementary code
			*/

			FCV_ASCII=ascii_tbl1[FCV_SCANCODE];


			//Comment:
			//ASCII now holds decoded
			//value from table, and
			//SCANcode = raw key value.


			//Num Lock key ?
			//Decision: SCANcode=0x77 AND NOT brk_bytes?
			if (FCV_SCANCODE==0x77 & ~ FCV_BRK_BYTES)
			{
				//Toggle Num LED
				//Calculation:
				//  LED = LED XOR 0x02
				//  NUMlock = NUMlock XOR 1
				FCV_LED = FCV_LED ^ 0x02;
				FCV_NUMLOCK = FCV_NUMLOCK ^ 1;
				

				//Update LEDs
				//Call Macro: LEDupdate
				FCM_LEDupdate();


			} else {
				//Caps Lock key ?
				//Decision: SCANcode=0x58?
				if (FCV_SCANCODE==0x58)
				{
					//ALT + Caps pressed?
					//Decision: ALT OR ALTgr?
					if (FCV_ALT | FCV_ALTGR)
					{
						//ALT+CTRL+Caps Pressed ?
						//Decision: CTRL?
						if (FCV_CTRL)
						{
							//Comment:
							//Toggle setting of
							//TK-II CAPS mode between
							//Atari and TK-II's
							//method.


							//Toggle Function
							//Calculation:
							//  TKcaps = TKcaps XOR 1
							//  temp = TKcaps XOR 1
							FCV_TKCAPS = FCV_TKCAPS ^ 1;
							FCV_TEMP = FCV_TKCAPS ^ 1;
							

							//Update Setting in EEPROM
							//Call Component Macro: EEPROM(0)::Write(222, TKcaps)
							FCD_EEPROM0_WriteEEPROM(222, FCV_TKCAPS);


							//Call Macro
							//Call Macro: WIggle(temp)
							FCM_WIggle(FCV_TEMP);


							//Delay
							//Delay: 250 ms
							delay_ms(250);


							//Comment:
							//If TKcaps = 0 then
							//TK-II CAPS Mode = OFF.
							//Deactivate Caps LED.


							//TK-II CAPS MODE OFF ?
							//Decision: TKcaps=0?
							if (FCV_TKCAPS==0)
							{
								//Turn OFF Caps LED
								//Calculation:
								//  LED = LED AND 0x03
								//  CAPS = 0
								FCV_LED = FCV_LED & 0x03;
								FCV_CAPS = 0;
								

								//Update LEDs
								//Call Macro: LEDupdate
								FCM_LEDupdate();


							} else {
								//Turn ON Caps LED
								//Calculation:
								//  LED = LED OR 0x04
								//  CAPS = 1
								FCV_LED = FCV_LED | 0x04;
								FCV_CAPS = 1;
								

								//Update LEDs
								//Call Macro: LEDupdate
								FCM_LEDupdate();


							}


							//Comment:
							//Because we need to
							//temporarily shut-down
							//KeyBd IRQ for LED updates
							//modifier key-ups get missed.


							//Comment:
							//And since we have
							//multiple modifiers
							//(CTRL+ALT) there's a
							//chance one will be missed.


							//Clear all Modifiers
							//Calculation:
							//  CTRL = 0
							//  SHIFT = 0
							//  ALT = 0
							FCV_CTRL = 0;
							FCV_SHIFT = 0;
							FCV_ALT = 0;
							

						} else {
							//Comment:
							//ALT+Caps key will display
							//the current Mode setting
							//as either ON or OFF.


							//Update and Display
							//Call Macro: ConfigRead(6, 1)
							FCM_ConfigRead(6, 1);


						}


					} else {
						//TK-II Caps Mode Active ?
						//Decision: TKcaps?
						if (FCV_TKCAPS)
						{
							//No Modifier Keys ?
							//Decision: SHIFT=0 AND CTRL=0?
							if (FCV_SHIFT==0 & FCV_CTRL==0)
							{
								//Comment:
								//Only toggles keyboard's
								//Caps Lock LED.
								//Does not change anything
								//on ATARI.


								//Comment:
								//But it does influence the
								//CASE of the Alpha keys
								//that will get sent to
								//the Atari.


								//Toggle Caps LED
								//Calculation:
								//  LED = LED XOR 0x04
								//  CAPS = CAPS XOR 1
								FCV_LED = FCV_LED ^ 0x04;
								FCV_CAPS = FCV_CAPS ^ 1;
								

								//Update LEDs
								//Call Macro: LEDupdate
								FCM_LEDupdate();


								//Comment:
								//If Caps Key is held
								//for 2 seconds, then
								//send actual Atari Caps
								//to re-sync.


								//Increment Sustain Counter
								//Calculation:
								//  Sustain = Sustain+1
								FCV_SUSTAIN = FCV_SUSTAIN+1;
								

								//2sec Sustained Caps Key ?
								//Decision: Sustain>12?
								if (FCV_SUSTAIN>12)
								{
									//Comment:
									//The idea is to put the
									//Atari into a lowercase
									//mode, and then shift to
									//create uppercase.


									//Comment:
									//So although we do this
									//upon power-up or reset,
									//if we get out of sync,
									//CAPS can be toggled.


									//Clear Sustain Counter
									//Calculation:
									//  Sustain = 0
									FCV_SUSTAIN = 0;
									

									//Turn ON Caps LED
									//Calculation:
									//  LED = LED OR 0x04
									//  CAPS = 1
									FCV_LED = FCV_LED | 0x04;
									FCV_CAPS = 1;
									

									//Update LEDs
									//Call Macro: LEDupdate
									FCM_LEDupdate();


									//Send CTRL+SHIFT+A
									//Calculation:
									//  POKEcode = 0xC0
									FCV_POKECODE = 0xC0;
									

									//Send It
									//Call Macro: KeySend2
									FCM_KeySend2();


									//Send ATARI Caps key
									//Calculation:
									//  POKEcode = 0x03
									//  POKEen = 1
									//  resync = 1
									FCV_POKECODE = 0x03;
									FCV_POKEEN = 1;
									FCV_RESYNC = 1;
									

								}


							} else {
								//Both SHIFT and CTRL ?
								//Decision: SHIFT AND CTRL?
								if (FCV_SHIFT & FCV_CTRL)
								{
									//Comment:
									//While in TK-II Caps
									//mode, independent
									//Shift or Control
									//are ignored.


									//Comment:
									//But simultaneous
									//Shift and Control
									//is acknowledged.


									//
									//Calculation:
									//  POKEcode = 0x03
									//  temp = SHIFT <<7
									//  temp = temp OR CTRL <<6
									//  POKEcode = temp OR POKEcode
									//  POKEen = 1
									FCV_POKECODE = 0x03;
									FCV_TEMP = FCV_SHIFT <<7;
									FCV_TEMP = FCV_TEMP | FCV_CTRL <<6;
									FCV_POKECODE = FCV_TEMP | FCV_POKECODE;
									FCV_POKEEN = 1;
									

								}


							}


						} else {
							//Comment:
							//Here's where Atari
							//Caps key is encoded
							//and sent.


							//Comment:
							//When in standard Atari
							//mode, all Caps key
							//combinations are sent
							//same as stock keyboard.


							//
							//Calculation:
							//  POKEcode = 0x03
							//  temp = SHIFT <<7
							//  temp = temp OR CTRL <<6
							//  POKEcode = temp OR POKEcode
							//  POKEen = 1
							FCV_POKECODE = 0x03;
							FCV_TEMP = FCV_SHIFT <<7;
							FCV_TEMP = FCV_TEMP | FCV_CTRL <<6;
							FCV_POKECODE = FCV_TEMP | FCV_POKECODE;
							FCV_POKEEN = 1;
							

						}


					}


				} else {
					//In TK-II Caps Mode ?
					//Decision: TKcaps>0?
					if (FCV_TKCAPS>0)
					{
						//Comment:
						//== TK-II CAPS MODE ==
						//Only when Shift and Caps
						//Lock are equal, does
						//alpha change to uppercase.


						//BOTH Caps Lock and Shift ?
						//Decision: SHIFT = CAPS?
						if (FCV_SHIFT == FCV_CAPS)
						{
						} else {
							//Alpha ?
							//Decision: ASCII>0x60 AND ASCII<0x7B?
							if (FCV_ASCII>0x60 & FCV_ASCII<0x7B)
							{
								//Convert Alpha to Uppercase
								//Calculation:
								//  ASCII = ASCII-0x20
								FCV_ASCII = FCV_ASCII-0x20;
								

							}


						}


					} else {
						//Comment:
						//== ATARI CAPS MODE ==
						//Shift will always change
						//ALPHA case to upper when
						//pressed.


						//Shift ?
						//Decision: SHIFT?
						if (FCV_SHIFT)
						{
							//Alpha ?
							//Decision: ASCII>0x60 AND ASCII<0x7B?
							if (FCV_ASCII>0x60 & FCV_ASCII<0x7B)
							{
								//Convert Alpha to Uppercase
								//Calculation:
								//  ASCII = ASCII-0x20
								FCV_ASCII = FCV_ASCII-0x20;
								

							}


						}


					}


					//Comment:
					//No matter what Caps
					//Mode we are in,
					//always change to
					//upper symbols.


					//Shift ?
					//Decision: SHIFT?
					if (FCV_SHIFT)
					{
						//Convert Symbols to Upper Char
						//Call Macro: Symbols
						FCM_Symbols();


					}


					//ALT Key Function ?
					//Decision: ALT OR ALTgr?
					if (FCV_ALT | FCV_ALTGR)
					{
						//Comment:
						//Handle ALT key combinations


						//Comment:
						//This command toggles
						//the arrow keys between
						//nav or normal +*-= keys
						//(setting is locked)


						//ALT+A key ?
						//Decision: SCANcode=0x1C?
						if (FCV_SCANCODE==0x1C)
						{
							//ALT+CTRL ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Toggle Arrow Speed
								//Calculation:
								//  ArrowSpeed = ArrowSpeed XOR 1
								//  temp = ArrowSpeed XOR 1
								FCV_ARROWSPEED = FCV_ARROWSPEED ^ 1;
								FCV_TEMP = FCV_ARROWSPEED ^ 1;
								

							} else {
								//Toggle Arrow Function
								//Calculation:
								//  ArrowTog = ArrowTog XOR 1
								//  temp = ArrowTog XOR 1
								FCV_ARROWTOG = FCV_ARROWTOG ^ 1;
								FCV_TEMP = FCV_ARROWTOG ^ 1;
								

							}


							//Call Macro
							//Call Macro: WIggle(temp)
							FCM_WIggle(FCV_TEMP);


						}


						//Comment:
						//Toggles special
						//Insert Mode from
						//either NAV or Numpad.


						//ALT+Insert key ?
						//Decision: SCANcode=0x70?
						if (FCV_SCANCODE==0x70)
						{
							//Toggle Insert Mode
							//Calculation:
							//  INSmode = INSmode XOR 0x01
							//  LED = (LED & 0x06) OR INSmode
							//  ASCII = 0
							FCV_INSMODE = FCV_INSMODE ^ 0x01;
							FCV_LED = (FCV_LED & 0x06) | FCV_INSMODE;
							FCV_ASCII = 0;
							

							//Update LEDs
							//Call Macro: LEDupdate
							FCM_LEDupdate();


						}


						//Comment:
						//On an XL or XE with
						//built-in BASIC, the
						//OPTION on boot will 
						//disable it.


						//ALT+O key?
						//Decision: SCANcode=0x44?
						if (FCV_SCANCODE==0x44)
						{
							//Toggle Command ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Comment:
								//CTRL+ALT+O will
								//toggle OPTION BOOT
								//to ON or OFF and
								//store the value in EEPROM.


								//Toggle OPTION Boot-Up BIT
								//Calculation:
								//  OptionBootEN = OptionBootEN XOR 1
								//  temp = OptionBootEN XOR 1
								FCV_OPTIONBOOTEN = FCV_OPTIONBOOTEN ^ 1;
								FCV_TEMP = FCV_OPTIONBOOTEN ^ 1;
								

								//Update Setting in EEPROM
								//Call Component Macro: EEPROM(0)::Write(30, OptionBootEN)
								FCD_EEPROM0_WriteEEPROM(30, FCV_OPTIONBOOTEN);


								//Call Macro
								//Call Macro: WIggle(temp)
								FCM_WIggle(FCV_TEMP);


							} else {
								//Comment:
								//ALT+O key will display
								//the Boot-Up state as
								//either OPTION ON or OFF.


								//Display Setting
								//Call Macro: ConfigRead(0, 1)
								FCM_ConfigRead(0, 1);


							}


						}


						//Comment:
						//XEGS have built-in
						//Game (Missle Command)
						//SELECT on boot will 
						//enable it.


						//ALT+G key?
						//Decision: SCANcode=0x34?
						if (FCV_SCANCODE==0x34)
						{
							//Toggle Command ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Comment:
								//CTRL+ALT+G will
								//toggle SELECT BOOT
								//to ON or OFF and
								//store the value in EEPROM.


								//Toggle SELECT Boot-Up BIT
								//Calculation:
								//  SelectBootEN = SelectBootEN XOR 1
								//  temp = SelectBootEN XOR 1
								FCV_SELECTBOOTEN = FCV_SELECTBOOTEN ^ 1;
								FCV_TEMP = FCV_SELECTBOOTEN ^ 1;
								

								//Update Setting in EEPROM
								//Call Component Macro: EEPROM(0)::Write(190, SelectBootEN)
								FCD_EEPROM0_WriteEEPROM(190, FCV_SELECTBOOTEN);


								//Call Macro
								//Call Macro: WIggle(temp)
								FCM_WIggle(FCV_TEMP);


							} else {
								//Comment:
								//ALT+G key will display
								//the Boot-Up state as
								//either SELECT ON or OFF.


								//Display Setting
								//Call Macro: ConfigRead(5, 1)
								FCM_ConfigRead(5, 1);


							}


						}


						//Comment:
						//On all Atari computers
						//they had a Screen Saver
						//called Attract Mode, this
						//allows it to be disabled.


						//ALT+S key?
						//Decision: SCANcode=0x1B?
						if (FCV_SCANCODE==0x1B)
						{
							//Toggle Command ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Comment:
								//CTRL+ALT+S will
								//toggle between Screen
								//Save ON or OFF and
								//store the value in EEPROM.


								//Toggle Screen Save Mode
								//Calculation:
								//  NoAttract = NoAttract XOR 1
								//  temp = NoAttract
								FCV_NOATTRACT = FCV_NOATTRACT ^ 1;
								FCV_TEMP = FCV_NOATTRACT;
								

								//Update Setting in EEPROM
								//Call Component Macro: EEPROM(0)::Write(62, NoAttract)
								FCD_EEPROM0_WriteEEPROM(62, FCV_NOATTRACT);


								//Reset Counters
								//Calculation:
								//  JIFFY1 = 0
								//  JIFFY2 = 0
								FCV_JIFFY1 = 0;
								FCV_JIFFY2 = 0;
								

								//Call Macro
								//Call Macro: WIggle(temp)
								FCM_WIggle(FCV_TEMP);


							} else {
								//Comment:
								//ALT+S key will display
								//the current Screen Saver
								//setting as either ON or OFF.


								//Update and Display
								//Call Macro: ConfigRead(1, 1)
								FCM_ConfigRead(1, 1);


							}


						}


						//Comment:
						//The XEGS doesn't have pull-
						//ups on POKEY's KR lines, so
						//TK-II can not float these lines
						//when used with the XEGS.


						//Comment:
						//This applies equally to
						//1200XL if stock keyboard
						//not plugged in.


						//ALT+X key?
						//Decision: SCANcode=0x22?
						if (FCV_SCANCODE==0x22)
						{
							//Toggle Command ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Comment:
								//CTRL+ALT+X will
								//toggle between a floated
								//or non-floated state and
								//store the value in EEPROM.


								//Toggle Float Bit
								//Calculation:
								//  float = float XOR 1
								//  temp = float
								FCV_FLOAT = FCV_FLOAT ^ 1;
								FCV_TEMP = FCV_FLOAT;
								

								//Update Setting in EEPROM
								//Call Component Macro: EEPROM(0)::Write(94, float)
								FCD_EEPROM0_WriteEEPROM(94, FCV_FLOAT);


								//Call Macro
								//Call Macro: WIggle(temp)
								FCM_WIggle(FCV_TEMP);


							} else {
								//Comment:
								//ALT+X key will display
								//the state of float as either
								//XEGS Mode ON or OFF.


								//Update and Display
								//Call Macro: ConfigRead(2, 1)
								FCM_ConfigRead(2, 1);


							}


						}


						//Comment:
						//Toggle for Alternate
						//Keyboard Mapping.


						//ALT+F4 key?
						//Decision: SCANcode=0x0C?
						if (FCV_SCANCODE==0x0C)
						{
							//Toggle Command ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Comment:
								//CTRL+ALT+F4 will
								//toggle between German
								//and US keyboard, then
								//store the value in EEPROM.


								//Calculation
								//Calculation:
								//  KeyMap = KeyMap+1
								FCV_KEYMAP = FCV_KEYMAP+1;
								

								//Over range ?
								//Decision: KeyMap>3?
								if (FCV_KEYMAP>3)
								{
									//Calculation
									//Calculation:
									//  KeyMap = 0
									FCV_KEYMAP = 0;
									

								}


								//Update Setting in EEPROM
								//Call Component Macro: EEPROM(0)::Write(126, KeyMap)
								FCD_EEPROM0_WriteEEPROM(126, FCV_KEYMAP);


								//Call Macro
								//Call Macro: WIggle(KeyMap)
								FCM_WIggle(FCV_KEYMAP);


							} else {
								//Comment:
								//ALT+F4 key will
								//display the setting of
								//the KeyMap.


								//Update and Display
								//Call Macro: ConfigRead(3, 1)
								FCM_ConfigRead(3, 1);


							}


						}


						//Comment:
						//This function toggles the
						//numbers 1,3,7,9 of the Num
						//pad between standard nav
						//or diagonal arrows.


						//ALT+NumPad 5 key?
						//Decision: SCANcode=0x73?
						if (FCV_SCANCODE==0x73)
						{
							//Toggle Command ?
							//Decision: CTRL?
							if (FCV_CTRL)
							{
								//Comment:
								//CTRL+ALT+NumPad 5 will
								//toggle between Diag Arrows
								//being ON or OFF and
								//store the value in EEPROM.


								//Toggle Diag Arrows Mode
								//Calculation:
								//  DiagArrows = DiagArrows XOR 1
								//  temp = DiagArrows XOR 1
								FCV_DIAGARROWS = FCV_DIAGARROWS ^ 1;
								FCV_TEMP = FCV_DIAGARROWS ^ 1;
								

								//Update Setting in EEPROM
								//Call Component Macro: EEPROM(0)::Write(158, DiagArrows)
								FCD_EEPROM0_WriteEEPROM(158, FCV_DIAGARROWS);


								//Call Macro
								//Call Macro: WIggle(temp)
								FCM_WIggle(FCV_TEMP);


							} else {
								//Comment:
								//ALT+NumPad 5 key will
								//display the setting of
								//Diag Arrows.


								//Update and Display
								//Call Macro: ConfigRead(4, 1)
								FCM_ConfigRead(4, 1);


							}


						}


						//Check for ALT-Key Macros
						//Call Macro: KeyMacros
						FCM_KeyMacros();


						//ALT+Arrows ?
						//Decision: SCANcode=0x6B OR SCANcode=0x72 OR SCANcode=0x74 OR SCANcode=0x75?
						if (FCV_SCANCODE==0x6B | FCV_SCANCODE==0x72 | FCV_SCANCODE==0x74 | FCV_SCANCODE==0x75)
						{
							//Comment:
							//=== FAST ARROWS ===
							//Uses 1200XL function
							//keys to double-step
							//the cursor.


							//Left
							//Decision: SCANcode=0x6B?
							if (FCV_SCANCODE==0x6B)
							{
								//
								//Calculation:
								//  POKEcode = 0x79
								FCV_POKECODE = 0x79;
								

								//Call Macro
								//Call Macro: KeySend2
								FCM_KeySend2();


								//
								//Calculation:
								//  POKEcode = 0x2C
								//  Nonkey = 1
								FCV_POKECODE = 0x2C;
								FCV_NONKEY = 1;
								

							}


							//Right
							//Decision: SCANcode=0x74?
							if (FCV_SCANCODE==0x74)
							{
								//
								//Calculation:
								//  POKEcode = 0x78
								FCV_POKECODE = 0x78;
								

								//Call Macro
								//Call Macro: KeySend2
								FCM_KeySend2();


								//
								//Calculation:
								//  POKEcode = 0x2B
								//  Nonkey = 1
								FCV_POKECODE = 0x2B;
								FCV_NONKEY = 1;
								

							}


							//Up
							//Decision: SCANcode=0x75?
							if (FCV_SCANCODE==0x75)
							{
								//
								//Calculation:
								//  POKEcode = 0x71
								FCV_POKECODE = 0x71;
								

								//Call Macro
								//Call Macro: KeySend2
								FCM_KeySend2();


								//
								//Calculation:
								//  POKEcode = 0x3C
								//  Nonkey = 1
								FCV_POKECODE = 0x3C;
								FCV_NONKEY = 1;
								

							}


							//Down
							//Decision: SCANcode=0x72?
							if (FCV_SCANCODE==0x72)
							{
								//
								//Calculation:
								//  POKEcode = 0x70
								FCV_POKECODE = 0x70;
								

								//Call Macro
								//Call Macro: KeySend2
								FCM_KeySend2();


								//
								//Calculation:
								//  POKEcode = 0x3B
								//  Nonkey = 1
								FCV_POKECODE = 0x3B;
								FCV_NONKEY = 1;
								

							}


						} else {
							//Disable Key Send
							//Calculation:
							//  POKEcode = 0x36
							FCV_POKECODE = 0x36;
							

							//German Keyboard ?
							//Decision: KeyMap=1?
							if (FCV_KEYMAP==1)
							{
								//ALTgr ?
								//Decision: ALTgr=1?
								if (FCV_ALTGR==1)
								{
									//
									//Decision: SCANcode=0x15?
									if (FCV_SCANCODE==0x15)
									{
										//
										//Calculation:
										//  POKEcode = 0x8A
										FCV_POKECODE = 0x8A;
										

									}


									//
									//Decision: SCANcode=0x3E?
									if (FCV_SCANCODE==0x3E)
									{
										//
										//Calculation:
										//  POKEcode = 0x9F
										FCV_POKECODE = 0x9F;
										

									}


									//
									//Decision: SCANcode=0x46?
									if (FCV_SCANCODE==0x46)
									{
										//
										//Calculation:
										//  POKEcode = 0x9D
										FCV_POKECODE = 0x9D;
										

									}


									//
									//Decision: SCANcode=0x4E?
									if (FCV_SCANCODE==0x4E)
									{
										//
										//Calculation:
										//  POKEcode = 0xB9
										FCV_POKECODE = 0xB9;
										

									}


									//
									//Decision: SCANcode=0x61?
									if (FCV_SCANCODE==0x61)
									{
										//
										//Calculation:
										//  POKEcode = 0xB0
										FCV_POKECODE = 0xB0;
										

									}


								}


							}


						}


					} else {
						//Numpad or Navigation keys ?
						//Decision: ASCII >0x8F?
						if (FCV_ASCII >0x8F)
						{
							//Interpret Navigation Keys
							//Call Macro: NumPad
							FCM_NumPad();


						}


						//Insert Mode Enabled ?
						//Decision: INSmode?
						if (FCV_INSMODE)
						{
							//Perform PC Style Insert
							//Call Macro: InsertMode
							FCM_InsertMode();


						}


						//Comment:
						//ASCII-TO-POKEY LUT
						//Translate ASCII into POKEY
						//scan matrix key codes.


						//Call Macro
						//Call Macro: Ascii2Pokey
						FCM_Ascii2Pokey();


						//Extended Key ?
						//Decision: ext_key?
						if (FCV_EXT_KEY)
						{
							//Print Screen key?
							//Decision: SCANcode = 0x7C?
							if (FCV_SCANCODE == 0x7C)
							{
								//Special Key Code
								//Calculation:
								//  POKEcode = 0x1B
								//  SCANcode = 0xFF
								//  Nonkey = 1
								FCV_POKECODE = 0x1B;
								FCV_SCANCODE = 0xFF;
								FCV_NONKEY = 1;
								

							}


						} else {
							//Numpad Insert or Del ?
							//Decision: SCANcode=0x70 OR SCANcode=0x71?
							if (FCV_SCANCODE==0x70 | FCV_SCANCODE==0x71)
							{
								//In Num Lock and Shifted?
								//Decision: NUMlock AND SHIFT?
								if (FCV_NUMLOCK & FCV_SHIFT)
								{
									//Strip SHIFT add CTRL
									//Calculation:
									//  POKEcode = POKEcode AND 0x7F
									//  POKEcode = POKEcode OR 0x40
									FCV_POKECODE = FCV_POKECODE & 0x7F;
									FCV_POKECODE = FCV_POKECODE | 0x40;
									

								}


								//Comment:
								//Force Single-Space Insert
								//or Delete from Numpad
								//when in Shifted and Num
								//Lock state.


								//Goto Connection Point
								//Goto Connection Point: [B]: B
								goto FCC_Main_B;


							}


						}


						//Embed SHIFT and CTRL Bits
						//Call Macro: ModEncode
						FCM_ModEncode();


						//Connection Point
						//Connection Point: [B]: B
FCC_Main_B:
;


						//Arrows ?
						//Decision: POKEcode=0x70 OR POKEcode=0x71 OR POKEcode=0x78 OR POKEcode=0x79?
						if (FCV_POKECODE==0x70 | FCV_POKECODE==0x71 | FCV_POKECODE==0x78 | FCV_POKECODE==0x79)
						{
							//Arrow Function Toggled ?
							//Decision: ArrowTog?
							if (FCV_ARROWTOG)
							{
								//Not CTRL'ed or SHIFTE'ed ?
								//Decision: CTRL=0 AND SHIFT=0?
								if (FCV_CTRL==0 & FCV_SHIFT==0)
								{
									//Decision
									//Decision: 0?
									if (0)
									{
									}


									//Comment:
									//Make the arrow keys
									//back into the normal
									//un-controlled and
									//un-shifted character.


									//Strip SHIFT and CTRL
									//Calculation:
									//  POKEcode = POKEcode AND 0x3F
									FCV_POKECODE = FCV_POKECODE & 0x3F;
									

								}


							} else {
								//Control pressed alone?
								//Decision: CTRL=1 AND SHIFT=0?
								if (FCV_CTRL==1 & FCV_SHIFT==0)
								{
									//Comment:
									//Make the arrow keys
									//back into the normal
									//un-controlled and
									//un-shifted character.


									//Strip SHIFT and CTRL
									//Calculation:
									//  POKEcode = POKEcode AND 0x3F
									FCV_POKECODE = FCV_POKECODE & 0x3F;
									

								} else {
									//High Speed Arrows ?
									//Decision: ArrowSpeed?
									if (FCV_ARROWSPEED)
									{
										//Comment:
										//Don't sustain arrow
										//keys when navigating.


										//Enable fast move
										//Calculation:
										//  Nonkey = 1
										FCV_NONKEY = 1;
										

									}


								}


							}


						}


						//Do Numpad Diag Arrows ?
						//Decision: DiagArrows=1 AND ext_key=0 AND (SCANcode=0x69 OR SCANcode=0x6C OR SCANcode=0x7A OR SCANcode=0x7D)?
						if (FCV_DIAGARROWS==1 & FCV_EXT_KEY==0 & (FCV_SCANCODE==0x69 | FCV_SCANCODE==0x6C | FCV_SCANCODE==0x7A | FCV_SCANCODE==0x7D))
						{
							//Are we go for Arrows?
							//Decision: (NUMlock=0 AND SHIFT=0) OR (NUMlock=1 AND SHIFT=1)?
							if ((FCV_NUMLOCK==0 & FCV_SHIFT==0) | (FCV_NUMLOCK==1 & FCV_SHIFT==1))
							{
								//Left-Down ?
								//Decision: SCANcode=0x69?
								if (FCV_SCANCODE==0x69)
								{
									//Left
									//Calculation:
									//  POKEcode = 0x79
									FCV_POKECODE = 0x79;
									

									//Send key
									//Call Macro: KeySend2
									FCM_KeySend2();


									//Down
									//Calculation:
									//  POKEcode = 0x70
									FCV_POKECODE = 0x70;
									

								}


								//Left-Up ?
								//Decision: SCANcode=0x6C?
								if (FCV_SCANCODE==0x6C)
								{
									//Left
									//Calculation:
									//  POKEcode = 0x79
									FCV_POKECODE = 0x79;
									

									//Send key
									//Call Macro: KeySend2
									FCM_KeySend2();


									//Up
									//Calculation:
									//  POKEcode = 0x71
									FCV_POKECODE = 0x71;
									

								}


								//Right-Down ?
								//Decision: SCANcode=0x7A?
								if (FCV_SCANCODE==0x7A)
								{
									//Right
									//Calculation:
									//  POKEcode = 0x78
									FCV_POKECODE = 0x78;
									

									//Send key
									//Call Macro: KeySend2
									FCM_KeySend2();


									//Down
									//Calculation:
									//  POKEcode = 0x70
									FCV_POKECODE = 0x70;
									

								}


								//Right-Up ?
								//Decision: SCANcode=0x7D?
								if (FCV_SCANCODE==0x7D)
								{
									//Right
									//Calculation:
									//  POKEcode = 0x78
									FCV_POKECODE = 0x78;
									

									//Send key
									//Call Macro: KeySend2
									FCM_KeySend2();


									//Up
									//Calculation:
									//  POKEcode = 0x71
									FCV_POKECODE = 0x71;
									

								}


								//
								//Calculation:
								//  Nonkey = 1
								FCV_NONKEY = 1;
								

							}


						}


						//Fix CTRL+SHIFT errors
						//Call Macro: CSfix
						FCM_CSfix();


						//Switch
						//Switch: KeyMap?
						switch (FCV_KEYMAP)
						{
							case 1:
							{
								//Translate German Keyboard
								//Call Macro: KeyMapDE
								FCM_KeyMapDE();


								break;
							}

							case 2:
							{
								//Translate UK Keyboard
								//Call Macro: KeyMapUK
								FCM_KeyMapUK();


								break;
							}

							case 3:
							{
								//Translate A8_ISO Keyboard
								//Call Macro: KeyMapA8
								FCM_KeyMapA8();


								break;
							}

							default:
							{
								//Comment:
								//Use US Keyboard


							}
						}


						//F12 key press (U1MB Menu)?
						//Decision: SCANcode=0x07?
						if (FCV_SCANCODE==0x07)
						{
							//Comment:
							//Ultimate 1 MB Menu
							//HELP+RESET
							//launch key


							//Set and Save Flag
							//Calculation:
							//  Umenu = 1
							//  UmenuTMP = 1
							FCV_UMENU = 1;
							FCV_UMENUTMP = 1;
							

							//Load Help key
							//Calculation:
							//  POKEcode = 0x2E
							//  POKEen = 1
							FCV_POKECODE = 0x2E;
							FCV_POKEEN = 1;
							

							//Comment:
							//Reset is added in
							//KeySend routine
							//after HELP key
							//send has initiated.


							//Send Help key
							//Call Macro: KeySend
							FCM_KeySend();


							//Save Caps State
							//Calculation:
							//  CAPStmp = CAPS
							FCV_CAPSTMP = FCV_CAPS;
							

							//Comment:
							//If TK-II Caps Mode is
							//active, and CAPS ON,
							//then temporarily
							//deactivate CAPS.


							//TK-II CAPS MODE ON ?
							//Decision: TKcaps=1 AND CAPS=1?
							if (FCV_TKCAPS==1 & FCV_CAPS==1)
							{
								//Turn OFF CAPS
								//Calculation:
								//  LED = LED AND 0x03
								//  CAPS = 0
								FCV_LED = FCV_LED & 0x03;
								FCV_CAPS = 0;
								

								//Update LEDs
								//Call Macro: LEDupdate
								FCM_LEDupdate();


							}


						}


						//U1MB Menu Accessed ?
						//Decision: UmenuTMP?
						if (FCV_UMENUTMP)
						{
							//Console Key Pressed ?
							//Decision: Console?
							if (FCV_CONSOLE)
							{
								//Comment:
								//Force Reboot of System
								//via Console key press.
								//i.e., if OPTION held,
								//will disable Basic.


								//Send 'C' Key
								//Calculation:
								//  POKEcode = 0x2D
								FCV_POKECODE = 0x2D;
								

							}


							//Comment:
							//Look for U1MB
							//shortcut keys.


							//B, C, Esc or X Key Pressed ?
							//Decision: POKEcode=0x23 OR POKEcode=0x29 OR POKEcode=0x2A OR POKEcode=0x2D?
							if (FCV_POKECODE==0x23 | FCV_POKECODE==0x29 | FCV_POKECODE==0x2A | FCV_POKECODE==0x2D)
							{
								//Comment:
								//Exiting U1MB menu...
								//Clear U1MB Flag and
								//set for non-sustained
								//key send.


								//
								//Calculation:
								//  UmenuTMP = 0
								//  Nonkey = 1
								FCV_UMENUTMP = 0;
								FCV_NONKEY = 1;
								

								//TK-II Caps or Console ?
								//Decision: TKcaps OR Console?
								if (FCV_TKCAPS | FCV_CONSOLE)
								{
									//Comment:
									//Force send of shortcut key


									//Get Ready to Send Key
									//Calculation:
									//  POKEen = 1
									FCV_POKEEN = 1;
									

									//Send It !
									//Call Macro: KeySend
									FCM_KeySend();


									//Console key down ?
									//Decision: Console?
									if (FCV_CONSOLE)
									{
										//Comment:
										//Hold momentary Console
										//key press so that it gets
										//acknowledged as a
										//'held' key instead.


										//Delay
										//Delay: 3 s
										delay_s(3);


										//Delay
										//Delay: 500 ms
										delay_ms(255);
										delay_ms(245);


									}


									//TK-II Caps Mode Active ?
									//Decision: TKcaps?
									if (FCV_TKCAPS)
									{
										//Comment:
										//Restore Caps Lock State.


										//Restore Caps
										//Calculation:
										//  CAPS = CAPStmp
										FCV_CAPS = FCV_CAPSTMP;
										

										//Caps ON ?
										//Decision: CAPS?
										if (FCV_CAPS)
										{
											//Turn ON Caps LED
											//Calculation:
											//  LED = LED OR 0x04
											FCV_LED = FCV_LED | 0x04;
											

											//Update LEDs
											//Call Macro: LEDupdate
											FCM_LEDupdate();


										}


										//Comment:
										//Resync Atari Caps setting
										//to match TK-II Caps Mode
										//requirement (lowercase).
										// 


										//Send Caps after long delay
										//Call Macro: CapsSync(225)
										FCM_CapsSync(225);


									}


								} else {
									//Comment:
									//Send shortcut key only.


								}


							}


						}


						//Comment:
						//Enable SHIFT key send
						//when no other key has
						//been pressed.


						//Shift ONLY down ?
						//Decision: SHIFT AND POKEcode=0x36?
						if (FCV_SHIFT & FCV_POKECODE==0x36)
						{
							//Set Shift Key Down
							//Calculation:
							//  shf_key = 0x2F
							//  POKEen = 1
							//  shf_only = 1
							FCV_SHF_KEY = 0x2F;
							FCV_POKEEN = 1;
							FCV_SHF_ONLY = 1;
							

						}


					}


					//Comment:
					//Processing of key code is
					//complete. Now to pass it thru
					//ClipBoard routine, prior to
					//being sent to POKEY.


					//Call Macro
					//Call Macro: ClipBoard
					FCM_ClipBoard();


				}


			}


		} else {
			//Comment:
			//If NoAttract Mode is set
			//(toggled by CTRL+ALT+S)
			//then deactivate ScreenSave.


			//ScreenSave Off ?
			//Decision: NoAttract?
			if (FCV_NOATTRACT)
			{
				//3 minutes passed ?
				//Decision: JIFFY2>240?
				if (FCV_JIFFY2>240)
				{
					//Comment:
					//Pressing CTRL+SHIFT+A
					//once every 3 minutes
					//is a nondisruptive way
					//to stop ScreenSave.


					//CTRL+SHIFT+A Key
					//Calculation:
					//  POKEcode = 0xC0
					FCV_POKECODE = 0xC0;
					

					//Send it
					//Call Macro: KeySend2
					FCM_KeySend2();


					//Reset Counters
					//Calculation:
					//  JIFFY1 = 0
					//  JIFFY2 = 0
					FCV_JIFFY1 = 0;
					FCV_JIFFY2 = 0;
					

				}


			}


		}


		//Send key
		//Call Macro: KeySend
		FCM_KeySend();


	}


	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
	//Handler code for [RB0INT]
	#ifndef MX_INTHANDLER_intcon_INTF
	#define MX_INTHANDLER_intcon_INTF
	if (ts_bit(intcon, INTF) && ts_bit(intcon, INTE))
	{
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 1;
		#endif	
		FCM_GetKey();
		cr_bit(intcon, INTF);
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 0;
		#endif	
	}
	#else
	#warning "This interrupt has previously been enabled, so the macro <GetKey> may never get called."
	#endif


	//Handler code for [RB0INT]
	#ifndef MX_INTHANDLER_intcon_INTF
	#define MX_INTHANDLER_intcon_INTF
	if (ts_bit(intcon, INTF) && ts_bit(intcon, INTE))
	{
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 1;
		#endif	
		FCM_GetKey();
		cr_bit(intcon, INTF);
		#ifdef USE_FLOWCODE_ICD
			extern char ICD_Interrupt_Enable = 0;
		#endif	
	}
	#else
	#warning "This interrupt has previously been enabled, so the macro <GetKey> may never get called."
	#endif


}



